// {{{RME classifier 'Logical View::CContextAddin'

#ifndef CContextAddin_H
#define CContextAddin_H

#ifdef PRAGMA
#pragma interface "CContextAddin.h"
#endif

#include <RTSystem/contextAddin.h>
#include <AddIn.h>
#include <CCmdTarget.h>
#include <ContextMenuItem.h>
class AddInCollection;
class AddInManager;
class Capsule;
class Class;
class Classifier;
class ClassifierCollection;
class ControllableElement;
class LogicalPackage;
class Model;
class RichType;
class _Application;
class _ControllableElementCollection;
class frmSelection;

// {{{RME classifier 'Logical View::CContextAddin' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class CContextAddin : public CCmdTarget
{
public:
	// {{{RME classifier 'Logical View::CContextAddin' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	DECLARE_DYNCREATE(CContextAddin)
	DECLARE_MESSAGE_MAP()
	DECLARE_OLECREATE(CContextAddin)

	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()

	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::CContextAddin' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::CContextAddin' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEIClasses::RRTEI::ContextMenuItem' associationEnd 'MyMenuItems_'
	ContextMenuItem MyMenuItems_[2];
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEIClasses::RRTEI::AddIn' associationEnd 'MyAddin_'
	AddIn MyAddin_;
	// }}}RME

public:
	// {{{RME classifier 'Logical View::CContextAddin' operation 'OnFinalRelease()'
	void OnFinalRelease( void );
	// }}}RME
	// {{{RME classifier 'Logical View::CContextAddin' operation '~CContextAddin()'
	~CContextAddin( void );
	// }}}RME
	// {{{RME classifier 'Logical View::CContextAddin' operation 'CContextAddin()'
	CContextAddin( void );
	// }}}RME
	// {{{RME classifier 'Logical View::CContextAddin' operation 'RunTest(LPDISPATCH)'
	void RunTest( LPDISPATCH theApp );
	// }}}RME
	// {{{RME classifier 'Logical View::CContextAddin' operation 'OnActivate(LPDISPATCH)'
	void OnActivate( LPDISPATCH theApp );
	// }}}RME
	// {{{RME classifier 'Logical View::CContextAddin' operation 'OnEnableContextMenuItemsForObjects(LPDISPATCH,LPDISPATCH)'
	BOOL OnEnableContextMenuItemsForObjects( LPDISPATCH theApp, LPDISPATCH theCollection );
	// }}}RME
	// {{{RME classifier 'Logical View::CContextAddin' operation 'OnSelectedContextMenuItemForObjects(LPDISPATCH,LPCTSTR,LPDISPATCH)'
	BOOL OnSelectedContextMenuItemForObjects( LPDISPATCH theApp, LPCTSTR theName, LPDISPATCH theCollection );
	// }}}RME
};

// {{{RME classifier 'Logical View::CContextAddin' classAttribute 'interfaceID'
extern IID interfaceID;
// }}}RME

// {{{RME classifier 'Logical View::CContextAddin' classAttribute 'addinName'
extern char * addinName;
// }}}RME

// {{{RME classifier 'Logical View::CContextAddin' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* CContextAddin_H */

// }}}RME
