// {{{RME classifier 'Logical View::CContextAddinApp'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "CContextAddinApp.h"
#endif

#include <RTSystem/contextAddin.h>
#include <CContextAddinApp.h>
#include <CContextAddin.h>

// {{{RME classifier 'Logical View::CContextAddinApp' tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR tool 'OT::Cpp' property 'ImplementationPreface'
BEGIN_MESSAGE_MAP(CContextAddinApp, CWinApp)
END_MESSAGE_MAP()

CContextAddinApp theApp;
// }}}USR
// }}}RME

// {{{RME classifier 'Logical View::CContextAddinApp' operation 'InitInstance()'
BOOL CContextAddinApp::InitInstance( void )
{
	// {{{USR operation 'InitInstance()'
	// Register all OLE server (factories) as running.  This enables the
	//  OLE libraries to create objects from other applications.
	COleObjectFactory::RegisterAll();

	return TRUE;
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::CContextAddinApp' operation 'DllGetClassObject(REFCLSID,REFIID,LPVOID*)'
STDAPI DllGetClassObject( REFCLSID rclsid, REFIID riid, LPVOID * ppv )
{
	// {{{USR operation 'DllGetClassObject(REFCLSID,REFIID,LPVOID*)'
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return AfxDllGetClassObject(rclsid, riid, ppv);
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::CContextAddinApp' operation 'DllCanUnloadNow()'
STDAPI DllCanUnloadNow( void )
{
	// {{{USR operation 'DllCanUnloadNow()'
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return AfxDllCanUnloadNow();
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::CContextAddinApp' operation 'DllRegisterServer()'
STDAPI DllRegisterServer( void )
{
	// {{{USR operation 'DllRegisterServer()'
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	COleObjectFactory::UpdateRegistryAll();
	return S_OK;
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::CContextAddinApp' operation 'UnregisterServer(REFCLSID,_TCHAR*)'
void UnregisterServer( REFCLSID rclsid, _TCHAR * szProgID )
{
	// {{{USR operation 'UnregisterServer(REFCLSID,_TCHAR*)'
	_TCHAR szID[256];
	wsprintf(szID, _T("{%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}"),
		rclsid.Data1, rclsid.Data2, rclsid.Data3,
		rclsid.Data4[0], rclsid.Data4[1], rclsid.Data4[2], rclsid.Data4[3],
		rclsid.Data4[4], rclsid.Data4[5], rclsid.Data4[6], rclsid.Data4[7]);
	CString sKey;
	sKey.Format(_T("%s\\%s"), _T("CLSID"), szID);
	AfxGetApp()->DelRegTree(HKEY_CLASSES_ROOT, sKey);
	sKey = szProgID;
	AfxGetApp()->DelRegTree(HKEY_CLASSES_ROOT, sKey);
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::CContextAddinApp' operation 'DllUnregisterServer()'
STDAPI DllUnregisterServer( void )
{
	// {{{USR operation 'DllUnregisterServer()'
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	UnregisterServer(CContextAddin::guid, addinName);
	return S_OK;
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::CContextAddinApp' tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR tool 'OT::Cpp' property 'ImplementationEnding'
// }}}USR
// }}}RME

// }}}RME
