// {{{RME classifier 'Logical View::frmSelection'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "frmSelection.h"
#endif

#include <RTSystem/contextAddin.h>
#include <frmSelection.h>

// {{{RME classifier 'Logical View::frmSelection' tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR tool 'OT::Cpp' property 'ImplementationPreface'
BEGIN_MESSAGE_MAP(frmSelection, CDialog)
END_MESSAGE_MAP()
// }}}USR
// }}}RME
// {{{RME classifier 'Logical View::frmSelection::ResourceID' tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR tool 'OT::Cpp' property 'ImplementationPreface'
// }}}USR
// }}}RME

// {{{RME classifier 'Logical View::frmSelection' operation 'frmSelection(CWnd*)'
frmSelection::frmSelection( CWnd * pParent )
	// {{{USR tool 'OT::Cpp' property 'ConstructorInitializer'
	:CDialog(frmSelection::IDD, pParent),
	numCapsules(0),
	numClasses(0)
	// }}}USR
{
	// {{{USR operation 'frmSelection(CWnd*)'
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::frmSelection' operation 'DoDataExchange(CDataExchange*)'
void frmSelection::DoDataExchange( CDataExchange * pDX )
{
	// {{{USR operation 'DoDataExchange(CDataExchange*)'
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST2, m_Classes);
	DDX_Control(pDX, IDC_LIST1, m_Capsules);

	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::frmSelection' operation 'OnInitDialog()'
BOOL frmSelection::OnInitDialog( void )
{
	// {{{USR operation 'OnInitDialog()'
	CDialog::OnInitDialog();

	/*******************************************************************/
	// The following code takes the data already stored in the dialog
	//  and populates the list boxses.
	/*******************************************************************/

	for (int i=0; i<numCapsules; i++)
	{
		m_Capsules.AddString(capsules[i]);
	}
	for (i=0; i<numClasses; i++)
	{
		m_Classes.AddString(classes[i]);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
				  // EXCEPTION: OCX Property Pages should return FALSE
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::frmSelection' tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR tool 'OT::Cpp' property 'ImplementationEnding'
// }}}USR
// }}}RME
// {{{RME classifier 'Logical View::frmSelection::ResourceID' tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR tool 'OT::Cpp' property 'ImplementationEnding'
// }}}USR
// }}}RME

// }}}RME
