// Machine generated IDispatch wrapper class(es) created with ClassWizard
/////////////////////////////////////////////////////////////////////////////
// _Application wrapper class

class _Application : public COleDispatchDriver
{
public:
	_Application() {}		// Calls COleDispatchDriver default constructor
	_Application(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	_Application(const _Application& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetVisible();
	void SetVisible(BOOL);
	short GetTop();
	void SetTop(short);
	short GetLeft();
	void SetLeft(short);
	short GetHeight();
	void SetHeight(short);
	short GetWidth();
	void SetWidth(short);
	LPDISPATCH GetCurrentModel();
	BOOL GetBrowserVisible();
	void SetBrowserVisible(BOOL);
	LPDISPATCH GetPathMap();
	CString GetVersion();
	CString GetProductName();
	CString GetApplicationPath();
	CString GetCommandLine();
	LPDISPATCH GetAddInManager();
	LPDISPATCH GetCurrentWorkspace();

// Operations
public:
	LPDISPATCH OpenModel(LPCTSTR theModel);
	LPDISPATCH NewModel();
	void Exit();
	void WriteErrorLog(LPCTSTR theMsg);
	void Save(BOOL bSaveUnits);
	void SaveAs(LPCTSTR theFile, BOOL bSaveUnits);
	void OpenScript(LPCTSTR FileName);
	void NewScript();
	void CompileScriptFile(LPCTSTR FileName, LPCTSTR BinaryName, BOOL bDebug);
	LPDISPATCH OpenModelAsTemplate(LPCTSTR szFileName);
	BOOL OpenURL(LPCTSTR theURL);
	BOOL OpenExternalDocument(LPCTSTR FileName);
	CString GetProfileString(LPCTSTR Section, LPCTSTR Entry, LPCTSTR Default);
	BOOL WriteProfileString(LPCTSTR Section, LPCTSTR Entry, LPCTSTR Value);
	LPDISPATCH GetLicensedApplication(LPCTSTR theKey);
	void ExecuteScript(LPCTSTR pFileName);
	void SetBuildSettings(BOOL ShowWarnings, BOOL VerifyConnectorCardinality, BOOL VerifyBranchTransitions, BOOL VerifyDeadUnreachableStates, BOOL VerifyUntriggeredTransitions);
	BOOL SaveGenerationResultsAs(LPCTSTR FileName);
	BOOL Get(LPDISPATCH pElements);
	BOOL CheckOut(LPDISPATCH pElements);
	BOOL UnCheckOut(LPDISPATCH pElements);
	BOOL CheckIn(LPDISPATCH pElements, LPCTSTR Comment);
	BOOL RefreshStatus(LPDISPATCH pElements);
	BOOL Add(LPDISPATCH pElements, BOOL addDirsToo, LPCTSTR Comment);
	BOOL AddDir(LPDISPATCH pElements, LPCTSTR Comment);
	BOOL IsSourceControlEnabled();
	void WriteBuildOutput(LPCTSTR strMessage);
	void WriteBuildError(LPCTSTR strError, LPDISPATCH pElement, short nLineNumber, BOOL bIsWarning);
	void WriteErrorLogEx(LPCTSTR pszMessage, LPDISPATCH pModelElement, BOOL bIsWarning);
	LPDISPATCH OpenWorkspace(LPCTSTR FileName);
	void SaveWorkspace();
	void SaveWorkspaceAs(LPCTSTR FileName);
	LPDISPATCH CreateCollection();
	BOOL CheckInDir(LPDISPATCH pElements, LPCTSTR Comment);
	void SelectObjectsInBrowsers(LPDISPATCH theObjects);
	void WriteBuildErrorEx(LPCTSTR strError, LPDISPATCH pElement, short nLineNumber, BOOL bIsWarning, LPDISPATCH pContext);
	BOOL SaveLogAs(LPCTSTR FileName);
	void LoadScript(LPCTSTR FileName);
	void FreeScript(LPCTSTR FileName);
	void ReportCodeSync(LPDISPATCH ocModelElements, LPDISPATCH ocContextElements, LPDISPATCH ocReplaceStrings);
	void SelectLogPane();
	void Browse(LPDISPATCH pElement, LPDISPATCH pContext, short nLineNumber);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// AddInManager wrapper class

class AddInManager : public COleDispatchDriver
{
public:
	AddInManager() {}		// Calls COleDispatchDriver default constructor
	AddInManager(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	AddInManager(const AddInManager& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	LPDISPATCH GetAddIns();

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// AddInCollection wrapper class

class AddInCollection : public COleDispatchDriver
{
public:
	AddInCollection() {}		// Calls COleDispatchDriver default constructor
	AddInCollection(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	AddInCollection(const AddInCollection& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	LPDISPATCH GetAt(short Index);
	short FindFirst(LPCTSTR Name);
	short FindNext(short iCurID, LPCTSTR Name);
	short IndexOf(LPDISPATCH theObject);
	void Add(LPDISPATCH theObject);
	void AddCollection(LPDISPATCH theCollection);
	void Remove(LPDISPATCH theObject);
	void RemoveAll();
	LPDISPATCH GetFirst(LPCTSTR Name);
	BOOL Exists(LPDISPATCH pObject);
	LPDISPATCH GetWithUniqueID(LPCTSTR UniqueID);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// AddIn wrapper class

class AddIn : public COleDispatchDriver
{
public:
	AddIn() {}		// Calls COleDispatchDriver default constructor
	AddIn(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	AddIn(const AddIn& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	LPDISPATCH GetEventHandler();
	CString GetName();
	CString GetServerName();
	LPDISPATCH GetToolNames();
	LPDISPATCH GetFundamentalTypes();
	CString GetRootRegistryPath();
	CString GetInstallDirectory();
	CString GetPropertyFilePath();
	CString GetMenuFilePath();
	CString GetHelpFilePath();
	CString GetCompanyName();
	CString GetVersion();
	CString GetCopyright();

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	void Activate();
	void Deactivate();
	BOOL IsActive();
	BOOL IsLanguageAddIn();
	void ExecuteScript(LPCTSTR FileName);
	CString ReadSetting(LPCTSTR Section, LPCTSTR Entry, LPCTSTR Default);
	BOOL WriteSetting(LPCTSTR Section, LPCTSTR Entry, LPCTSTR Value);
	BOOL IsRTAddIn();
	LPDISPATCH GetContextMenuItemsForClass(LPCTSTR itemType);
	LPDISPATCH AddContextMenuItemForClass(LPCTSTR itemType, LPCTSTR fullCaption, LPCTSTR InternalName);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// ContextMenuItem wrapper class

class ContextMenuItem : public COleDispatchDriver
{
public:
	ContextMenuItem() {}		// Calls COleDispatchDriver default constructor
	ContextMenuItem(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ContextMenuItem(const ContextMenuItem& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetCaption();
	CString GetInternalName();
	void SetInternalName(LPCTSTR);
	short GetMenuID();
	LPDISPATCH GetMenuState();

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// Class wrapper class

class Class : public COleDispatchDriver
{
public:
	Class() {}		// Calls COleDispatchDriver default constructor
	Class(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	Class(const Class& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	BOOL GetAbstract();
	void SetAbstract(BOOL);
	LPDISPATCH GetParentLogicalPackage();
	LPDISPATCH GetAttributes();
	LPDISPATCH GetOperations();
	LPDISPATCH GetVisibility();
	LPDISPATCH GetStateMachine();
	BOOL GetSystemClass();
	void SetSystemClass(BOOL);
	LPDISPATCH GetCollaborations();
	CString GetAssignedLanguage();
	BOOL GetPersistence();
	void SetPersistence(BOOL);
	LPDISPATCH GetClassKind();
	LPDISPATCH GetConcurrency();
	BOOL GetFundamentalType();
	void SetFundamentalType(BOOL);
	CString GetSpace();
	void SetSpace(LPCTSTR);
	LPDISPATCH GetParameters();
	CString GetMultiplicity();
	void SetMultiplicity(LPCTSTR);
	LPDISPATCH GetParentClass();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	LPDISPATCH GetClassifier();
	LPDISPATCH GetGeneralizations();
	LPDISPATCH GetSuperClasses();
	LPDISPATCH GetSubClasses();
	LPDISPATCH AddGeneralization(LPCTSTR theRelationName, LPCTSTR theParentClassName);
	BOOL DeleteGeneralization(LPDISPATCH theGeneralization);
	LPDISPATCH AddOperation(LPCTSTR theName, LPCTSTR retType);
	BOOL DeleteOperation(LPDISPATCH theOper);
	LPDISPATCH AddAttribute(LPCTSTR theName, LPCTSTR theType, LPCTSTR initVal);
	BOOL DeleteAttribute(LPDISPATCH theAttr);
	LPDISPATCH GetAssociations();
	LPDISPATCH AddAssociation(LPCTSTR theSupplierRoleName, LPCTSTR theSupplierRoleType);
	BOOL DeleteAssociation(LPDISPATCH thAss);
	LPDISPATCH GetAssociationEnds();
	LPDISPATCH GetAssociateAssociationEnds();
	void CreateStateMachine();
	void DeleteStateMachine();
	LPDISPATCH AddRealizeRel(LPCTSTR theRelationName, LPCTSTR theSupplierName);
	BOOL DeleteRealizeRel(LPDISPATCH theRel);
	LPDISPATCH GetRealizeRelations();
	LPDISPATCH GetClassDependencies();
	LPDISPATCH AddClassDependency(LPCTSTR thSupplierName, LPCTSTR theSupplierType);
	BOOL DeleteClassDependency(LPDISPATCH theDependency);
	LPDISPATCH AddCollaboration(LPCTSTR theCollabName);
	BOOL DeleteCollaboration(LPDISPATCH theCollab);
	LPDISPATCH AddGeneralizationEx(LPCTSTR theRelationName, LPCTSTR theParentClassName, BOOL ExcludeSuperclassProps);
	BOOL DeleteGeneralizationEx(LPDISPATCH theGeneralization, BOOL AbsorbSuperClassProps);
	LPDISPATCH GetNestedClasses();
	LPDISPATCH AddNestedClass(LPCTSTR theName);
	BOOL DeleteNestedClass(LPDISPATCH theClass);
	BOOL IsNestedClass();
	LPDISPATCH AddParameter(LPCTSTR theName, LPCTSTR theType, LPCTSTR theDef, short position);
	LPDISPATCH AddInstantiateRel(LPCTSTR theRelationName, LPCTSTR theParentClassName);
	LPDISPATCH GetInstantiateRelations();
	BOOL DeleteInstantiateRel(LPDISPATCH theInstantiateRel);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// Classifier wrapper class

class Classifier : public COleDispatchDriver
{
public:
	Classifier() {}		// Calls COleDispatchDriver default constructor
	Classifier(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	Classifier(const Classifier& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	BOOL GetAbstract();
	void SetAbstract(BOOL);
	LPDISPATCH GetParentLogicalPackage();
	LPDISPATCH GetAttributes();
	LPDISPATCH GetOperations();
	LPDISPATCH GetVisibility();
	LPDISPATCH GetStateMachine();
	BOOL GetSystemClass();
	void SetSystemClass(BOOL);
	LPDISPATCH GetCollaborations();
	CString GetAssignedLanguage();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	LPDISPATCH GetClassifier();
	LPDISPATCH GetGeneralizations();
	LPDISPATCH GetSuperClasses();
	LPDISPATCH GetSubClasses();
	LPDISPATCH AddGeneralization(LPCTSTR theRelationName, LPCTSTR theParentClassName);
	BOOL DeleteGeneralization(LPDISPATCH theGeneralization);
	LPDISPATCH AddOperation(LPCTSTR theName, LPCTSTR retType);
	BOOL DeleteOperation(LPDISPATCH theOper);
	LPDISPATCH AddAttribute(LPCTSTR theName, LPCTSTR theType, LPCTSTR initVal);
	BOOL DeleteAttribute(LPDISPATCH theAttr);
	LPDISPATCH GetAssociations();
	LPDISPATCH AddAssociation(LPCTSTR theSupplierRoleName, LPCTSTR theSupplierRoleType);
	BOOL DeleteAssociation(LPDISPATCH thAss);
	LPDISPATCH GetAssociationEnds();
	LPDISPATCH GetAssociateAssociationEnds();
	void CreateStateMachine();
	void DeleteStateMachine();
	LPDISPATCH AddRealizeRel(LPCTSTR theRelationName, LPCTSTR theSupplierName);
	BOOL DeleteRealizeRel(LPDISPATCH theRel);
	LPDISPATCH GetRealizeRelations();
	LPDISPATCH GetClassDependencies();
	LPDISPATCH AddClassDependency(LPCTSTR thSupplierName, LPCTSTR theSupplierType);
	BOOL DeleteClassDependency(LPDISPATCH theDependency);
	LPDISPATCH AddCollaboration(LPCTSTR theCollabName);
	BOOL DeleteCollaboration(LPDISPATCH theCollab);
	LPDISPATCH AddGeneralizationEx(LPCTSTR theRelationName, LPCTSTR theParentClassName, BOOL ExcludeSuperclassProps);
	BOOL DeleteGeneralizationEx(LPDISPATCH theGeneralization, BOOL AbsorbSuperClassProps);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// Capsule wrapper class

class Capsule : public COleDispatchDriver
{
public:
	Capsule() {}		// Calls COleDispatchDriver default constructor
	Capsule(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	Capsule(const Capsule& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	BOOL GetAbstract();
	void SetAbstract(BOOL);
	LPDISPATCH GetParentLogicalPackage();
	LPDISPATCH GetAttributes();
	LPDISPATCH GetOperations();
	LPDISPATCH GetVisibility();
	LPDISPATCH GetStateMachine();
	BOOL GetSystemClass();
	void SetSystemClass(BOOL);
	LPDISPATCH GetCollaborations();
	CString GetAssignedLanguage();
	LPDISPATCH GetStructure();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	LPDISPATCH GetClassifier();
	LPDISPATCH GetGeneralizations();
	LPDISPATCH GetSuperClasses();
	LPDISPATCH GetSubClasses();
	LPDISPATCH AddGeneralization(LPCTSTR theRelationName, LPCTSTR theParentClassName);
	BOOL DeleteGeneralization(LPDISPATCH theGeneralization);
	LPDISPATCH AddOperation(LPCTSTR theName, LPCTSTR retType);
	BOOL DeleteOperation(LPDISPATCH theOper);
	LPDISPATCH AddAttribute(LPCTSTR theName, LPCTSTR theType, LPCTSTR initVal);
	BOOL DeleteAttribute(LPDISPATCH theAttr);
	LPDISPATCH GetAssociations();
	LPDISPATCH AddAssociation(LPCTSTR theSupplierRoleName, LPCTSTR theSupplierRoleType);
	BOOL DeleteAssociation(LPDISPATCH thAss);
	LPDISPATCH GetAssociationEnds();
	LPDISPATCH GetAssociateAssociationEnds();
	void CreateStateMachine();
	void DeleteStateMachine();
	LPDISPATCH AddRealizeRel(LPCTSTR theRelationName, LPCTSTR theSupplierName);
	BOOL DeleteRealizeRel(LPDISPATCH theRel);
	LPDISPATCH GetRealizeRelations();
	LPDISPATCH GetClassDependencies();
	LPDISPATCH AddClassDependency(LPCTSTR thSupplierName, LPCTSTR theSupplierType);
	BOOL DeleteClassDependency(LPDISPATCH theDependency);
	LPDISPATCH AddCollaboration(LPCTSTR theCollabName);
	BOOL DeleteCollaboration(LPDISPATCH theCollab);
	LPDISPATCH AddGeneralizationEx(LPCTSTR theRelationName, LPCTSTR theParentClassName, BOOL ExcludeSuperclassProps);
	BOOL DeleteGeneralizationEx(LPDISPATCH theGeneralization, BOOL AbsorbSuperClassProps);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// ClassifierCollection wrapper class

class ClassifierCollection : public COleDispatchDriver
{
public:
	ClassifierCollection() {}		// Calls COleDispatchDriver default constructor
	ClassifierCollection(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ClassifierCollection(const ClassifierCollection& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	LPDISPATCH GetAt(short Index);
	short FindFirst(LPCTSTR Name);
	short FindNext(short iCurID, LPCTSTR Name);
	short IndexOf(LPDISPATCH theObject);
	void Add(LPDISPATCH theObject);
	void AddCollection(LPDISPATCH theCollection);
	void Remove(LPDISPATCH theObject);
	void RemoveAll();
	LPDISPATCH GetFirst(LPCTSTR Name);
	BOOL Exists(LPDISPATCH pObject);
	LPDISPATCH GetWithUniqueID(LPCTSTR UniqueID);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// AttributeCollection wrapper class

class AttributeCollection : public COleDispatchDriver
{
public:
	AttributeCollection() {}		// Calls COleDispatchDriver default constructor
	AttributeCollection(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	AttributeCollection(const AttributeCollection& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	LPDISPATCH GetAt(short Index);
	short FindFirst(LPCTSTR Name);
	short FindNext(short iCurID, LPCTSTR Name);
	short IndexOf(LPDISPATCH theObject);
	void Add(LPDISPATCH theObject);
	void AddCollection(LPDISPATCH theCollection);
	void Remove(LPDISPATCH theObject);
	void RemoveAll();
	LPDISPATCH GetFirst(LPCTSTR Name);
	BOOL Exists(LPDISPATCH pObject);
	LPDISPATCH GetWithUniqueID(LPCTSTR UniqueID);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// Model wrapper class

class Model : public COleDispatchDriver
{
public:
	Model() {}		// Calls COleDispatchDriver default constructor
	Model(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	Model(const Model& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	LPDISPATCH GetRootLogicalPackage();
	LPDISPATCH GetRootComponentPackage();
	LPDISPATCH GetDeploymentDiagram();
	LPDISPATCH GetUseCases();
	LPDISPATCH GetRootUseCaseLogicalPackage();
	LPDISPATCH GetDefaultProperties();
	LPDISPATCH GetRootDeploymentPackage();
	LPDISPATCH GetActiveComponent();
	void SetActiveComponent(LPDISPATCH);
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	BOOL IsRootPackage();
	BOOL ImportFile(LPCTSTR FileName);
	BOOL AddUnit(LPCTSTR FileName);
	BOOL AddSharedUnit(LPCTSTR FileName);
	LPDISPATCH ImportFileEx(LPCTSTR FileName);
	BOOL TopLevel();
	LPDISPATCH AddProcessor(LPCTSTR pName);
	LPDISPATCH GetActiveDiagram();
	BOOL DeleteProcessor(LPDISPATCH pProcessor);
	LPDISPATCH AddDevice(LPCTSTR pName);
	BOOL DeleteDevice(LPDISPATCH pDevice);
	LPDISPATCH GetSelectedClasses();
	LPDISPATCH GetSelectedLogicalPackages();
	LPDISPATCH GetSelectedComponents();
	LPDISPATCH GetSelectedComponentPackages();
	LPDISPATCH GetAllClasses();
	LPDISPATCH GetAllLogicalPackages();
	LPDISPATCH GetAllComponents();
	LPDISPATCH GetAllComponentPackages();
	LPDISPATCH GetAllProcessors();
	LPDISPATCH GetAllDevices();
	LPDISPATCH GetSelectedUseCases();
	LPDISPATCH GetAllUseCases();
	LPDISPATCH GetAllAssociations();
	LPDISPATCH FindModelElements(LPCTSTR ModelElementName);
	LPDISPATCH FindModelElementWithID(LPCTSTR UniqueID);
	LPDISPATCH FindClasses(LPCTSTR ClassName);
	LPDISPATCH FindClassWithID(LPCTSTR UniqueID);
	LPDISPATCH FindLogicalPackages(LPCTSTR LogicalPackageName);
	LPDISPATCH FindLogicalPackageWithID(LPCTSTR UniqueID);
	BOOL ControlAllUnits(BOOL bControlAllUnits);
	LPDISPATCH GetAllCapsules();
	LPDISPATCH GetAllProtocols();
	LPDISPATCH FindCapsules(LPCTSTR capsuleName);
	LPDISPATCH FindProtocols(LPCTSTR protocolName);
	LPDISPATCH GetSelectedModelElements();
	LPDISPATCH GetActiveComponentInstances();
	BOOL AddActiveComponentInstance(LPDISPATCH ComponentInstanceToAdd);
	BOOL RemoveActiveComponentInstance(LPDISPATCH ComponentInstanceToRemove);
	LPDISPATCH FindCapsuleWithID(LPCTSTR UniqueID);
	LPDISPATCH FindProtocolWithID(LPCTSTR UniqueID);
	LPDISPATCH GetSelectedCapsules();
	LPDISPATCH GetSelectedProtocols();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// LogicalPackage wrapper class

class LogicalPackage : public COleDispatchDriver
{
public:
	LogicalPackage() {}		// Calls COleDispatchDriver default constructor
	LogicalPackage(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	LogicalPackage(const LogicalPackage& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	BOOL GetGlobal();
	void SetGlobal(BOOL);
	LPDISPATCH GetClasses();
	LPDISPATCH GetLogicalPackages();
	LPDISPATCH GetParentLogicalPackage();
	LPDISPATCH GetClassDiagrams();
	LPDISPATCH GetAssociations();
	LPDISPATCH GetUseCases();
	LPDISPATCH GetCapsules();
	LPDISPATCH GetProtocols();
	LPDISPATCH GetCollaborations();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	BOOL IsRootPackage();
	BOOL ImportFile(LPCTSTR FileName);
	BOOL AddUnit(LPCTSTR FileName);
	BOOL AddSharedUnit(LPCTSTR FileName);
	LPDISPATCH ImportFileEx(LPCTSTR FileName);
	LPDISPATCH GetAllClasses();
	LPDISPATCH GetAllLogicalPackages();
	LPDISPATCH AddClass(LPCTSTR theName);
	LPDISPATCH AddClassDiagram(LPCTSTR Name);
	LPDISPATCH AddLogicalPackage(LPCTSTR theName);
	void RelocateClass(LPDISPATCH theClass);
	void RelocateLogicalPackage(LPDISPATCH theLogicalPackage);
	void RelocateClassDiagram(LPDISPATCH theClsDiagram);
	BOOL DeleteLogicalPackage(LPDISPATCH theLogicalPackage);
	BOOL DeleteClass(LPDISPATCH theClass);
	BOOL DeleteClassDiagram(LPDISPATCH theClassDiagram);
	LPDISPATCH GetAssignedComponentPackage();
	void SetAssignedComponentPackage(LPDISPATCH newValue);
	BOOL HasAssignedComponentPackage();
	BOOL DeleteUseCase(LPDISPATCH theUseCase);
	BOOL TopLevel();
	LPDISPATCH GetAllUseCases();
	LPDISPATCH AddUseCase(LPCTSTR szName);
	LPDISPATCH AddLogicalPackageDependency(LPCTSTR theName, LPCTSTR theSupplierLogicalPackageName);
	LPDISPATCH GetLogicalPackageDependencies();
	BOOL DeleteLogicalPackageDependency(LPDISPATCH theDependency);
	LPDISPATCH AddCapsule(LPCTSTR Name);
	BOOL DeleteCapsule(LPDISPATCH theCapsule);
	BOOL RelocateCapsule(LPDISPATCH theCapsule);
	LPDISPATCH AddProtocol(LPCTSTR Name);
	BOOL DeleteProtocol(LPDISPATCH theProtocol);
	BOOL RelocateProtocol(LPDISPATCH theProtocol);
	LPDISPATCH AddCollaboration(LPCTSTR Name);
	BOOL DeleteCollaboration(LPDISPATCH theCollaboration);
	BOOL RelocateCollaboration(LPDISPATCH theCollaboration);
	LPDISPATCH GetAllCapsules();
	LPDISPATCH GetAllProtocols();
	LPDISPATCH GetGeneralizations();
	LPDISPATCH AddGeneralization(LPCTSTR theRelationName, LPCTSTR theParentLogicalPackageName);
	BOOL DeleteGeneralization(LPDISPATCH theGeneralization);
	LPDISPATCH GetSuperLogicalPackages();
	LPDISPATCH GetSubLogicalPackages();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// RichType wrapper class

class RichType : public COleDispatchDriver
{
public:
	RichType() {}		// Calls COleDispatchDriver default constructor
	RichType(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	RichType(const RichType& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetValue();
	void SetValue(short);
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetTypes();

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// PropertyCollection wrapper class

class PropertyCollection : public COleDispatchDriver
{
public:
	PropertyCollection() {}		// Calls COleDispatchDriver default constructor
	PropertyCollection(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	PropertyCollection(const PropertyCollection& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	LPDISPATCH GetAt(short Index);
	short FindFirst(LPCTSTR Name);
	short FindNext(short iCurID, LPCTSTR Name);
	short IndexOf(LPDISPATCH theObject);
	void Add(LPDISPATCH theObject);
	void AddCollection(LPDISPATCH theCollection);
	void Remove(LPDISPATCH theObject);
	void RemoveAll();
	LPDISPATCH GetFirst(LPCTSTR Name);
	BOOL Exists(LPDISPATCH pObject);
	LPDISPATCH GetWithUniqueID(LPCTSTR UniqueID);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// Property wrapper class

class Property : public COleDispatchDriver
{
public:
	Property() {}		// Calls COleDispatchDriver default constructor
	Property(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	Property(const Property& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	CString GetValue();
	void SetValue(LPCTSTR);
	CString GetToolName();
	CString GetType();

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// OperationCollection wrapper class

class OperationCollection : public COleDispatchDriver
{
public:
	OperationCollection() {}		// Calls COleDispatchDriver default constructor
	OperationCollection(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	OperationCollection(const OperationCollection& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	LPDISPATCH GetAt(short Index);
	short FindFirst(LPCTSTR Name);
	short FindNext(short iCurID, LPCTSTR Name);
	short IndexOf(LPDISPATCH theObject);
	void Add(LPDISPATCH theObject);
	void AddCollection(LPDISPATCH theCollection);
	void Remove(LPDISPATCH theObject);
	void RemoveAll();
	LPDISPATCH GetFirst(LPCTSTR Name);
	BOOL Exists(LPDISPATCH pObject);
	LPDISPATCH GetWithUniqueID(LPCTSTR UniqueID);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// Operation wrapper class

class Operation : public COleDispatchDriver
{
public:
	Operation() {}		// Calls COleDispatchDriver default constructor
	Operation(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	Operation(const Operation& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	CString GetReturnType();
	void SetReturnType(LPCTSTR);
	LPDISPATCH GetParameters();
	LPDISPATCH GetVisibility();
	LPDISPATCH GetConcurrency();
	CString GetPreconditions();
	void SetPreconditions(LPCTSTR);
	CString GetSemantics();
	void SetSemantics(LPCTSTR);
	CString GetPostconditions();
	void SetPostconditions(LPCTSTR);
	CString GetProtocol();
	void SetProtocol(LPCTSTR);
	CString GetQualification();
	void SetQualification(LPCTSTR);
	CString GetExceptions();
	void SetExceptions(LPCTSTR);
	CString GetSize();
	void SetSize(LPCTSTR);
	CString GetTime();
	void SetTime(LPCTSTR);
	BOOL GetVirtual();
	void SetVirtual(BOOL);
	LPDISPATCH GetParentClassifier();
	BOOL GetAbstract();
	void SetAbstract(BOOL);
	BOOL GetQuery();
	void SetQuery(BOOL);
	CString GetCode();
	void SetCode(LPCTSTR);
	LPDISPATCH GetOwnerScope();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	LPDISPATCH AddParameter(LPCTSTR theName, LPCTSTR theType, LPCTSTR theDef, short position);
	BOOL DeleteParameter(LPDISPATCH theParameter);
	void RemoveAllParameters();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// ParameterCollection wrapper class

class ParameterCollection : public COleDispatchDriver
{
public:
	ParameterCollection() {}		// Calls COleDispatchDriver default constructor
	ParameterCollection(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ParameterCollection(const ParameterCollection& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	LPDISPATCH GetAt(short Index);
	short FindFirst(LPCTSTR Name);
	short FindNext(short iCurID, LPCTSTR Name);
	short IndexOf(LPDISPATCH theObject);
	void Add(LPDISPATCH theObject);
	void AddCollection(LPDISPATCH theCollection);
	void Remove(LPDISPATCH theObject);
	void RemoveAll();
	LPDISPATCH GetFirst(LPCTSTR Name);
	BOOL Exists(LPDISPATCH pObject);
	LPDISPATCH GetWithUniqueID(LPCTSTR UniqueID);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// Parameter wrapper class

class Parameter : public COleDispatchDriver
{
public:
	Parameter() {}		// Calls COleDispatchDriver default constructor
	Parameter(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	Parameter(const Parameter& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	BOOL GetConst();
	void SetConst(BOOL);
	CString GetType();
	void SetType(LPCTSTR);
	CString GetInitValue();
	void SetInitValue(LPCTSTR);
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// ClassDependencyCollection wrapper class

class ClassDependencyCollection : public COleDispatchDriver
{
public:
	ClassDependencyCollection() {}		// Calls COleDispatchDriver default constructor
	ClassDependencyCollection(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ClassDependencyCollection(const ClassDependencyCollection& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	LPDISPATCH GetAt(short Index);
	short FindFirst(LPCTSTR Name);
	short FindNext(short iCurID, LPCTSTR Name);
	short IndexOf(LPDISPATCH theObject);
	void Add(LPDISPATCH theObject);
	void AddCollection(LPDISPATCH theCollection);
	void Remove(LPDISPATCH theObject);
	void RemoveAll();
	LPDISPATCH GetFirst(LPCTSTR Name);
	BOOL Exists(LPDISPATCH pObject);
	LPDISPATCH GetWithUniqueID(LPCTSTR UniqueID);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// ClassDependency wrapper class

class ClassDependency : public COleDispatchDriver
{
public:
	ClassDependency() {}		// Calls COleDispatchDriver default constructor
	ClassDependency(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ClassDependency(const ClassDependency& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	CString GetSupplierName();
	void SetSupplierName(LPCTSTR);
	CString GetClientCardinality();
	void SetClientCardinality(LPCTSTR);
	CString GetSupplierCardinality();
	void SetSupplierCardinality(LPCTSTR);
	LPDISPATCH GetVisibility();
	BOOL GetInvolvesFriendship();
	void SetInvolvesFriendship(BOOL);
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	BOOL HasClient();
	BOOL HasSupplier();
	LPDISPATCH GetClient();
	LPDISPATCH GetSupplier();
	LPDISPATCH GetContextClassifier();
	LPDISPATCH GetSupplierClassifier();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// PathMap wrapper class

class PathMap : public COleDispatchDriver
{
public:
	PathMap() {}		// Calls COleDispatchDriver default constructor
	PathMap(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	PathMap(const PathMap& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:

// Operations
public:
	BOOL AddEntry(LPCTSTR Symbol, LPCTSTR Path, LPCTSTR Comment);
	BOOL DeleteEntry(LPCTSTR Symbol);
	CString GetActualPath(LPCTSTR VirtualPath);
	CString GetVirtualPath(LPCTSTR ActualPath);
	BOOL HasEntry(LPCTSTR Symbol);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// Association wrapper class

class Association : public COleDispatchDriver
{
public:
	Association() {}		// Calls COleDispatchDriver default constructor
	Association(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	Association(const Association& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	BOOL GetDerived();
	void SetDerived(BOOL);
	LPDISPATCH GetAssociationClass();
	void SetAssociationClass(LPDISPATCH);
	LPDISPATCH GetEnds();
	LPDISPATCH GetEnd1();
	LPDISPATCH GetEnd2();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	LPDISPATCH GetCorrespondingAssociationEnd(LPDISPATCH Classifier);
	LPDISPATCH GetOtherAssociationEnd(LPDISPATCH Classifier);
	BOOL NameIsDirectional();
	LPDISPATCH GetAssociationEndForNameDirection();
	void SetAssociationEndForNameDirection(LPDISPATCH theAssociationEnd);
	void ClearAssociationEndForNameDirection();
	BOOL SetEnds(LPDISPATCH End1, LPDISPATCH End2);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// AssociationCollection wrapper class

class AssociationCollection : public COleDispatchDriver
{
public:
	AssociationCollection() {}		// Calls COleDispatchDriver default constructor
	AssociationCollection(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	AssociationCollection(const AssociationCollection& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	LPDISPATCH GetAt(short Index);
	short FindFirst(LPCTSTR Name);
	short FindNext(short iCurID, LPCTSTR Name);
	short IndexOf(LPDISPATCH theObject);
	void Add(LPDISPATCH theObject);
	void AddCollection(LPDISPATCH theCollection);
	void Remove(LPDISPATCH theObject);
	void RemoveAll();
	LPDISPATCH GetFirst(LPCTSTR Name);
	BOOL Exists(LPDISPATCH pObject);
	LPDISPATCH GetWithUniqueID(LPCTSTR UniqueID);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// AssociationEndCollection wrapper class

class AssociationEndCollection : public COleDispatchDriver
{
public:
	AssociationEndCollection() {}		// Calls COleDispatchDriver default constructor
	AssociationEndCollection(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	AssociationEndCollection(const AssociationEndCollection& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	LPDISPATCH GetAt(short Index);
	short FindFirst(LPCTSTR Name);
	short FindNext(short iCurID, LPCTSTR Name);
	short IndexOf(LPDISPATCH theObject);
	void Add(LPDISPATCH theObject);
	void AddCollection(LPDISPATCH theCollection);
	void Remove(LPDISPATCH theObject);
	void RemoveAll();
	LPDISPATCH GetFirst(LPCTSTR Name);
	BOOL Exists(LPDISPATCH pObject);
	LPDISPATCH GetWithUniqueID(LPCTSTR UniqueID);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// AssociationEnd wrapper class

class AssociationEnd : public COleDispatchDriver
{
public:
	AssociationEnd() {}		// Calls COleDispatchDriver default constructor
	AssociationEnd(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	AssociationEnd(const AssociationEnd& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	CString GetSupplierName();
	void SetSupplierName(LPCTSTR);
	BOOL GetAggregate();
	void SetAggregate(BOOL);
	BOOL GetStatic();
	void SetStatic(BOOL);
	BOOL GetFriend();
	void SetFriend(BOOL);
	BOOL GetNavigable();
	void SetNavigable(BOOL);
	LPDISPATCH GetContainment();
	LPDISPATCH GetAssociation();
	LPDISPATCH GetClassifier();
	LPDISPATCH GetKeys();
	LPDISPATCH GetAssociateModelElement();
	LPDISPATCH GetUseCase();
	CString GetConstraints();
	void SetConstraints(LPCTSTR);
	CString GetMultiplicity();
	void SetMultiplicity(LPCTSTR);
	LPDISPATCH GetVisibility();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	BOOL HasClient();
	BOOL HasSupplier();
	LPDISPATCH GetClient();
	LPDISPATCH GetSupplier();
	LPDISPATCH AddKey(LPCTSTR theName, LPCTSTR theType);
	BOOL DeleteKey(LPDISPATCH theAttr);
	CString GetClassName();
	BOOL IsAssociateClass();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// Attribute wrapper class

class Attribute : public COleDispatchDriver
{
public:
	Attribute() {}		// Calls COleDispatchDriver default constructor
	Attribute(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	Attribute(const Attribute& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	CString GetInitValue();
	void SetInitValue(LPCTSTR);
	CString GetType();
	void SetType(LPCTSTR);
	LPDISPATCH GetContainment();
	BOOL GetDerived();
	void SetDerived(BOOL);
	LPDISPATCH GetParentClassifier();
	LPDISPATCH GetOwnerScope();
	LPDISPATCH GetVisibility();
	LPDISPATCH GetChangeable();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// ControllableElement wrapper class

class ControllableElement : public COleDispatchDriver
{
public:
	ControllableElement() {}		// Calls COleDispatchDriver default constructor
	ControllableElement(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ControllableElement(const ControllableElement& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// _ControllableElementCollection wrapper class

class _ControllableElementCollection : public COleDispatchDriver
{
public:
	_ControllableElementCollection() {}		// Calls COleDispatchDriver default constructor
	_ControllableElementCollection(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	_ControllableElementCollection(const _ControllableElementCollection& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	LPDISPATCH GetAt(short Index);
	short FindFirst(LPCTSTR Name);
	short FindNext(short iCurID, LPCTSTR Name);
	short IndexOf(LPDISPATCH theObject);
	void Add(LPDISPATCH theObject);
	void AddCollection(LPDISPATCH theCollection);
	void Remove(LPDISPATCH theObject);
	void RemoveAll();
	LPDISPATCH GetFirst(LPCTSTR Name);
	BOOL Exists(LPDISPATCH pObject);
	LPDISPATCH GetWithUniqueID(LPCTSTR UniqueID);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// ClassifierRoleCollection wrapper class

class ClassifierRoleCollection : public COleDispatchDriver
{
public:
	ClassifierRoleCollection() {}		// Calls COleDispatchDriver default constructor
	ClassifierRoleCollection(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ClassifierRoleCollection(const ClassifierRoleCollection& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	LPDISPATCH GetAt(short Index);
	short FindFirst(LPCTSTR Name);
	short FindNext(short iCurID, LPCTSTR Name);
	short IndexOf(LPDISPATCH theObject);
	void Add(LPDISPATCH theObject);
	void AddCollection(LPDISPATCH theCollection);
	void Remove(LPDISPATCH theObject);
	void RemoveAll();
	LPDISPATCH GetFirst(LPCTSTR Name);
	BOOL Exists(LPDISPATCH pObject);
	LPDISPATCH GetWithUniqueID(LPCTSTR UniqueID);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// ClassifierRole wrapper class

class ClassifierRole : public COleDispatchDriver
{
public:
	ClassifierRole() {}		// Calls COleDispatchDriver default constructor
	ClassifierRole(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ClassifierRole(const ClassifierRole& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	LPDISPATCH GetParentCollaboration();
	LPDISPATCH GetClassifier();
	void SetClassifier(LPDISPATCH);
	CString GetMultiplicity();
	void SetMultiplicity(LPCTSTR);
	CString GetClassifierName();
	void SetClassifierName(LPCTSTR);
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	LPDISPATCH ClassifierRole_();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// InteractionInstanceCollection wrapper class

class InteractionInstanceCollection : public COleDispatchDriver
{
public:
	InteractionInstanceCollection() {}		// Calls COleDispatchDriver default constructor
	InteractionInstanceCollection(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	InteractionInstanceCollection(const InteractionInstanceCollection& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	LPDISPATCH GetAt(short Index);
	short FindFirst(LPCTSTR Name);
	short FindNext(short iCurID, LPCTSTR Name);
	short IndexOf(LPDISPATCH theObject);
	void Add(LPDISPATCH theObject);
	void AddCollection(LPDISPATCH theCollection);
	void Remove(LPDISPATCH theObject);
	void RemoveAll();
	LPDISPATCH GetFirst(LPCTSTR Name);
	BOOL Exists(LPDISPATCH pObject);
	LPDISPATCH GetWithUniqueID(LPCTSTR UniqueID);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// InteractionInstance wrapper class

class InteractionInstance : public COleDispatchDriver
{
public:
	InteractionInstance() {}		// Calls COleDispatchDriver default constructor
	InteractionInstance(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	InteractionInstance(const InteractionInstance& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	LPDISPATCH GetParentInteraction();
	LPDISPATCH GetEvents();
	LPDISPATCH GetClassifierRoles();
	LPDISPATCH GetRootClassifier();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	BOOL ReorderMessageEnd(LPDISPATCH theEnd, LPDISPATCH pBefore);
	BOOL AddClassifierRole(LPDISPATCH theRole);
	BOOL RemoveClassifierRole(LPDISPATCH theRole);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// Diagram wrapper class

class Diagram : public COleDispatchDriver
{
public:
	Diagram() {}		// Calls COleDispatchDriver default constructor
	Diagram(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	Diagram(const Diagram& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	BOOL GetVisible();
	void SetVisible(BOOL);
	LPDISPATCH GetViewElements();
	LPDISPATCH GetModelElements();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	LPDISPATCH GetParentModelElement();
	short GetZoomFactor();
	void SetZoomFactor(short);
	LPDISPATCH GetExternalDocuments();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	void Layout();
	void Invalidate();
	void Update();
	LPDISPATCH GetViewFrom(LPDISPATCH theModelElement);
	BOOL Exists(LPDISPATCH theModelElement);
	void Render(LPCTSTR FileName);
	LPDISPATCH GetNoteViews();
	void RenderEnhanced(LPCTSTR FileName);
	void RenderToClipboard();
	void RenderEnhancedToClipboard();
	BOOL IsActive();
	void Activate();
	LPDISPATCH GetSelectedModelElements();
	BOOL DeleteExternalDocument(LPDISPATCH theExtDoc);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH AddAnchorNoteView(LPDISPATCH FromView, LPDISPATCH ToView);
	BOOL RemoveAnchorNoteView(LPDISPATCH AnchorNoteView);
	LPDISPATCH AddNoteView(LPCTSTR szNoteText, long nType);
	BOOL RemoveNoteView(LPDISPATCH pIDispNoteView);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// ClassDiagram wrapper class

class ClassDiagram : public COleDispatchDriver
{
public:
	ClassDiagram() {}		// Calls COleDispatchDriver default constructor
	ClassDiagram(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ClassDiagram(const ClassDiagram& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	BOOL GetVisible();
	void SetVisible(BOOL);
	LPDISPATCH GetViewElements();
	LPDISPATCH GetModelElements();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	LPDISPATCH GetParentModelElement();
	short GetZoomFactor();
	void SetZoomFactor(short);
	LPDISPATCH GetExternalDocuments();
	LPDISPATCH GetParentLogicalPackage();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	void Layout();
	void Invalidate();
	void Update();
	LPDISPATCH GetViewFrom(LPDISPATCH theModelElement);
	BOOL Exists(LPDISPATCH theModelElement);
	void Render(LPCTSTR FileName);
	LPDISPATCH GetNoteViews();
	void RenderEnhanced(LPCTSTR FileName);
	void RenderToClipboard();
	void RenderEnhancedToClipboard();
	BOOL IsActive();
	void Activate();
	LPDISPATCH GetSelectedModelElements();
	BOOL DeleteExternalDocument(LPDISPATCH theExtDoc);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH AddAnchorNoteView(LPDISPATCH FromView, LPDISPATCH ToView);
	BOOL RemoveAnchorNoteView(LPDISPATCH AnchorNoteView);
	LPDISPATCH AddNoteView(LPCTSTR szNoteText, long nType);
	BOOL RemoveNoteView(LPDISPATCH pIDispNoteView);
	BOOL AddClass(LPDISPATCH theClass);
	BOOL AddLogicalPackage(LPDISPATCH theCat);
	LPDISPATCH GetSelectedLogicalPackages();
	LPDISPATCH GetSelectedClasses();
	LPDISPATCH GetClasses();
	LPDISPATCH GetLogicalPackages();
	BOOL AddAssociation(LPDISPATCH theAssociation);
	BOOL RemoveClass(LPDISPATCH theClass);
	BOOL RemoveLogicalPackage(LPDISPATCH theLogicalPackage);
	BOOL RemoveAssociation(LPDISPATCH theAssociation);
	LPDISPATCH GetAssociations();
	BOOL AddUseCase(LPDISPATCH theUseCase);
	BOOL RemoveUseCase(LPDISPATCH theUseCase);
	LPDISPATCH GetUseCases();
	BOOL IsUseCaseDiagram();
	LPDISPATCH GetClassView(LPDISPATCH theClass);
	BOOL AddCapsule(LPDISPATCH theCapsule);
	BOOL AddProtocol(LPDISPATCH theProtocol);
	BOOL RemoveCapsule(LPDISPATCH theCapsule);
	BOOL RemoveProtocol(LPDISPATCH theProtocol);
	LPDISPATCH GetCapsuleView(LPDISPATCH theCapsule);
	LPDISPATCH GetProtocolView(LPDISPATCH theProtocol);
	LPDISPATCH GetSelectedCapsules();
	LPDISPATCH GetSelectedProtocols();
	LPDISPATCH GetCapsules();
	LPDISPATCH GetProtocols();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// CollaborationDiagram wrapper class

class CollaborationDiagram : public COleDispatchDriver
{
public:
	CollaborationDiagram() {}		// Calls COleDispatchDriver default constructor
	CollaborationDiagram(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	CollaborationDiagram(const CollaborationDiagram& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	BOOL GetVisible();
	void SetVisible(BOOL);
	LPDISPATCH GetViewElements();
	LPDISPATCH GetModelElements();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	LPDISPATCH GetParentModelElement();
	short GetZoomFactor();
	void SetZoomFactor(short);
	LPDISPATCH GetExternalDocuments();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	void Layout();
	void Invalidate();
	void Update();
	LPDISPATCH GetViewFrom(LPDISPATCH theModelElement);
	BOOL Exists(LPDISPATCH theModelElement);
	void Render(LPCTSTR FileName);
	LPDISPATCH GetNoteViews();
	void RenderEnhanced(LPCTSTR FileName);
	void RenderToClipboard();
	void RenderEnhancedToClipboard();
	BOOL IsActive();
	void Activate();
	LPDISPATCH GetSelectedModelElements();
	BOOL DeleteExternalDocument(LPDISPATCH theExtDoc);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH AddAnchorNoteView(LPDISPATCH FromView, LPDISPATCH ToView);
	BOOL RemoveAnchorNoteView(LPDISPATCH AnchorNoteView);
	LPDISPATCH AddNoteView(LPCTSTR szNoteText, long nType);
	BOOL RemoveNoteView(LPDISPATCH pIDispNoteView);
	LPDISPATCH AddCapsuleRoleView(LPDISPATCH pCapsulerRole);
	LPDISPATCH AddClassifierRoleView(LPDISPATCH pClassifierRole);
	LPDISPATCH AddPortView(LPDISPATCH pPort);
	LPDISPATCH AddConnectorView(LPDISPATCH pConnector);
	LPDISPATCH AddAssociationRoleView(LPDISPATCH pAssocRole);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// SequenceDiagram wrapper class

class SequenceDiagram : public COleDispatchDriver
{
public:
	SequenceDiagram() {}		// Calls COleDispatchDriver default constructor
	SequenceDiagram(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	SequenceDiagram(const SequenceDiagram& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	BOOL GetVisible();
	void SetVisible(BOOL);
	LPDISPATCH GetViewElements();
	LPDISPATCH GetModelElements();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	LPDISPATCH GetParentModelElement();
	short GetZoomFactor();
	void SetZoomFactor(short);
	LPDISPATCH GetExternalDocuments();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	void Layout();
	void Invalidate();
	void Update();
	LPDISPATCH GetViewFrom(LPDISPATCH theModelElement);
	BOOL Exists(LPDISPATCH theModelElement);
	void Render(LPCTSTR FileName);
	LPDISPATCH GetNoteViews();
	void RenderEnhanced(LPCTSTR FileName);
	void RenderToClipboard();
	void RenderEnhancedToClipboard();
	BOOL IsActive();
	void Activate();
	LPDISPATCH GetSelectedModelElements();
	BOOL DeleteExternalDocument(LPDISPATCH theExtDoc);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH AddAnchorNoteView(LPDISPATCH FromView, LPDISPATCH ToView);
	BOOL RemoveAnchorNoteView(LPDISPATCH AnchorNoteView);
	LPDISPATCH AddNoteView(LPCTSTR szNoteText, long nType);
	BOOL RemoveNoteView(LPDISPATCH pIDispNoteView);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// ModelElement wrapper class

class ModelElement : public COleDispatchDriver
{
public:
	ModelElement() {}		// Calls COleDispatchDriver default constructor
	ModelElement(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ModelElement(const ModelElement& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// GeneralizationCollection wrapper class

class GeneralizationCollection : public COleDispatchDriver
{
public:
	GeneralizationCollection() {}		// Calls COleDispatchDriver default constructor
	GeneralizationCollection(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	GeneralizationCollection(const GeneralizationCollection& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	LPDISPATCH GetAt(short Index);
	short FindFirst(LPCTSTR Name);
	short FindNext(short iCurID, LPCTSTR Name);
	short IndexOf(LPDISPATCH theObject);
	void Add(LPDISPATCH theObject);
	void AddCollection(LPDISPATCH theCollection);
	void Remove(LPDISPATCH theObject);
	void RemoveAll();
	LPDISPATCH GetFirst(LPCTSTR Name);
	BOOL Exists(LPDISPATCH pObject);
	LPDISPATCH GetWithUniqueID(LPCTSTR UniqueID);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// Generalization wrapper class

class Generalization : public COleDispatchDriver
{
public:
	Generalization() {}		// Calls COleDispatchDriver default constructor
	Generalization(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	Generalization(const Generalization& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	CString GetSupplierName();
	void SetSupplierName(LPCTSTR);
	BOOL GetVirtual();
	void SetVirtual(BOOL);
	BOOL GetFriendshipRequired();
	void SetFriendshipRequired(BOOL);
	LPDISPATCH GetVisibility();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	BOOL HasClient();
	BOOL HasSupplier();
	LPDISPATCH GetClient();
	LPDISPATCH GetSupplier();
	LPDISPATCH GetContextClassifier();
	LPDISPATCH GetSupplierClassifier();
	LPDISPATCH GetContextPackage();
	LPDISPATCH GetSupplierPackage();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// LogicalPackageCollection wrapper class

class LogicalPackageCollection : public COleDispatchDriver
{
public:
	LogicalPackageCollection() {}		// Calls COleDispatchDriver default constructor
	LogicalPackageCollection(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	LogicalPackageCollection(const LogicalPackageCollection& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	LPDISPATCH GetAt(short Index);
	short FindFirst(LPCTSTR Name);
	short FindNext(short iCurID, LPCTSTR Name);
	short IndexOf(LPDISPATCH theObject);
	void Add(LPDISPATCH theObject);
	void AddCollection(LPDISPATCH theCollection);
	void Remove(LPDISPATCH theObject);
	void RemoveAll();
	LPDISPATCH GetFirst(LPCTSTR Name);
	BOOL Exists(LPDISPATCH pObject);
	LPDISPATCH GetWithUniqueID(LPCTSTR UniqueID);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// DeploymentPackage wrapper class

class DeploymentPackage : public COleDispatchDriver
{
public:
	DeploymentPackage() {}		// Calls COleDispatchDriver default constructor
	DeploymentPackage(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	DeploymentPackage(const DeploymentPackage& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	LPDISPATCH GetDeploymentDiagrams();
	LPDISPATCH GetParentDeploymentPackage();
	LPDISPATCH GetDeploymentPackages();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	LPDISPATCH GetAllProcessors();
	LPDISPATCH AddDevice(LPCTSTR pName);
	LPDISPATCH AddProcessor(LPCTSTR pName);
	BOOL DeleteDevice(LPDISPATCH pDevice);
	BOOL DeleteProcessor(LPDISPATCH pProcessor);
	LPDISPATCH GetAllDevices();
	BOOL DeleteDeploymentPackage(LPDISPATCH theDeploymentPackageToDelete);
	LPDISPATCH AddDeploymentPackage(LPCTSTR theName);
	LPDISPATCH AddDeploymentDiagram(LPCTSTR Name);
	BOOL DeleteDeploymentDiagram(LPDISPATCH theDeploymentDiagram);
	BOOL RelocateDevice(LPDISPATCH theDevice);
	BOOL RelocateProcessor(LPDISPATCH theProcessor);
	BOOL RelocateDeploymentPackage(LPDISPATCH theDeploymentPackage);
	BOOL RelocateDeploymentDiagram(LPDISPATCH theDeploymentDiagram);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	BOOL IsRootPackage();
	BOOL ImportFile(LPCTSTR FileName);
	BOOL AddUnit(LPCTSTR FileName);
	BOOL AddSharedUnit(LPCTSTR FileName);
	LPDISPATCH ImportFileEx(LPCTSTR FileName);
	BOOL TopLevel();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// Component wrapper class

class Component : public COleDispatchDriver
{
public:
	Component() {}		// Calls COleDispatchDriver default constructor
	Component(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	Component(const Component& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	LPDISPATCH GetParentComponentPackage();
	LPDISPATCH GetAssignedClasses();
	LPDISPATCH GetAssignedLogicalPackages();
	CString GetEnvironment();
	void SetEnvironment(LPCTSTR);
	CString GetType();
	void SetType(LPCTSTR);
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	LPDISPATCH GetRealizeRelations();
	BOOL AssignClass(LPDISPATCH theClass);
	BOOL UnassignClass(LPDISPATCH theClass);
	BOOL AssignPackage(LPDISPATCH thePackage);
	BOOL UnassignPackage(LPDISPATCH thePackage);
	LPDISPATCH GetComponentDependencies();
	LPDISPATCH AddComponentDependency(LPDISPATCH theDep);
	BOOL DeleteComponentDependency(LPDISPATCH theDep);
	LPDISPATCH AddRealizeRelation(LPCTSTR theRelName, LPCTSTR theInterfaceName);
	BOOL DeleteRealizeRelation(LPDISPATCH theRel);
	LPDISPATCH GetAllClasses();
	BOOL Verify(BOOL bUpdateAssignedClassList);
	BOOL Generate(BOOL bUpdateAssignedClassList);
	BOOL Build(BOOL bUpdateAssignedClassList);
	BOOL RebuildAll(BOOL bUpdateAssignedClassList);
	BOOL UpdateAssignedClassList();
	BOOL ReverifyAll(BOOL bUpdateAssignedClassList);
	BOOL RegenerateAll(BOOL bUpdateAssignedClassList);
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// ComponentPackage wrapper class

class ComponentPackage : public COleDispatchDriver
{
public:
	ComponentPackage() {}		// Calls COleDispatchDriver default constructor
	ComponentPackage(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ComponentPackage(const ComponentPackage& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	LPDISPATCH GetParentComponentPackage();
	LPDISPATCH GetComponentPackages();
	LPDISPATCH GetComponents();
	LPDISPATCH GetComponentDiagrams();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	BOOL IsRootPackage();
	BOOL ImportFile(LPCTSTR FileName);
	BOOL AddUnit(LPCTSTR FileName);
	BOOL AddSharedUnit(LPCTSTR FileName);
	LPDISPATCH ImportFileEx(LPCTSTR FileName);
	LPDISPATCH AddComponent(LPCTSTR theName);
	LPDISPATCH AddComponentDiagram(LPCTSTR Name);
	LPDISPATCH AddComponentPackage(LPCTSTR theName);
	void RelocateComponent(LPDISPATCH theComponent);
	void RelocateComponentPackage(LPDISPATCH theComponentPackage);
	void RelocateComponentDiagram(LPDISPATCH theModDiagram);
	LPDISPATCH GetAllComponents();
	LPDISPATCH GetAllComponentPackages();
	LPDISPATCH GetVisibleComponentPackages();
	LPDISPATCH GetComponentPackageDependencies(LPDISPATCH theComponentPackage);
	BOOL TopLevel();
	BOOL DeleteComponent(LPDISPATCH pIDispatch);
	BOOL DeleteComponentPackage(LPDISPATCH pIDispatch);
	LPDISPATCH GetComponentDependencies();
	LPDISPATCH GetObject();
};
/////////////////////////////////////////////////////////////////////////////
// Processor wrapper class

class Processor : public COleDispatchDriver
{
public:
	Processor() {}		// Calls COleDispatchDriver default constructor
	Processor(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	Processor(const Processor& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	void SetName(LPCTSTR);
	LPDISPATCH GetApplication();
	LPDISPATCH GetModel();
	CString GetDocumentation();
	void SetDocumentation(LPCTSTR);
	CString GetStereotype();
	void SetStereotype(LPCTSTR);
	CString GetLocalizedStereotype();
	void SetLocalizedStereotype(LPCTSTR);
	LPDISPATCH GetExternalDocuments();
	LPDISPATCH GetComponentInstances();
	CString GetOs();
	void SetOs(LPCTSTR);
	CString GetCpu();
	void SetCpu(LPCTSTR);
	CString GetAddress();
	void SetAddress(LPCTSTR);
	CString GetUserScriptDirectory();
	void SetUserScriptDirectory(LPCTSTR);
	CString GetServerAddress();
	void SetServerAddress(LPCTSTR);
	LPDISPATCH GetParentDeploymentPackage();
	BOOL GetControlNewUnits();
	void SetControlNewUnits(BOOL);

// Operations
public:
	BOOL IsClass(LPCTSTR theClassName);
	CString IdentifyClass();
	BOOL IsSameInstance(LPDISPATCH Other);
	CString GetUniqueID();
	CString GetQualifiedName();
	CString GetCurrentPropertySetName(LPCTSTR ToolName);
	BOOL OverrideProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue);
	BOOL InheritProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL CreateProperty(LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType);
	CString GetPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetDefaultPropertyValue(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH GetAllProperties();
	LPDISPATCH GetToolProperties(LPCTSTR theToolName);
	BOOL IsOverriddenProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	BOOL IsDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	LPDISPATCH FindDefaultProperty(LPCTSTR theToolName, LPCTSTR thePropName);
	CString GetPropertyClassName();
	LPDISPATCH GetDefaultSetNames(LPCTSTR ToolName);
	LPDISPATCH GetToolNames();
	BOOL SetCurrentPropertySetName(LPCTSTR ToolName, LPCTSTR SetName);
	LPDISPATCH GetConnectedDevices();
	LPDISPATCH GetConnectedProcessors();
	LPDISPATCH AddComponentInstance(LPCTSTR Name);
	BOOL DeleteComponentInstance(LPDISPATCH theComponentInstance);
	BOOL AddProcessorConnection(LPDISPATCH Processor);
	BOOL RemoveProcessorConnection(LPDISPATCH theProcessor);
	BOOL AddDeviceConnection(LPDISPATCH theDevice);
	BOOL RemoveDeviceConnection(LPDISPATCH theDevice);
	BOOL IsControlled();
	BOOL IsModified();
	BOOL IsModifiable();
	CString GetFileName();
	BOOL Save();
	LPDISPATCH GetContainingControlledElement();
	LPDISPATCH GetControlledChildElements(BOOL bRecursive);
	BOOL IsOwned();
	BOOL IsUnderSourceControl();
	BOOL IsCheckedOut();
	CString GetVersion();
	BOOL IsLoaded();
	BOOL Uncontrol();
	BOOL ControlChildElements(BOOL Recursive);
	BOOL UncontrolChildElements(BOOL Recursive);
	BOOL ControlTo(LPCTSTR Path);
	BOOL Control();
	BOOL IsChildDirUnderSourceControl();
	BOOL IsControllableElementContainer();
	BOOL IsChildDirCheckedOut();
	CString GetChildDirName();
	BOOL IsScratchPad();
	LPDISPATCH GetModelElement();
	BOOL DeleteExternalDocument(LPDISPATCH pIDispatch);
	LPDISPATCH AddExternalDocument(LPCTSTR szName, long iType);
	BOOL OpenSpecification();
	LPDISPATCH GetObject();
};
