// {{{RME classifier 'Logical View::RRTEI::AddInCollection'

#ifndef AddInCollection_H
#define AddInCollection_H

#ifdef PRAGMA
#pragma interface "AddInCollection.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::AddInCollection' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class AddInCollection : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~AddInCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	AddInCollection & operator=( const AddInCollection & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'AddInCollection()'
	AddInCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'AddInCollection(LPDISPATCH)'
	AddInCollection( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'AddInCollection(const AddInCollection&)'
	AddInCollection( const AddInCollection & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'Add(LPDISPATCH)'
	void Add( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'GetCount()'
	short GetCount( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'GetAt(short)'
	LPDISPATCH GetAt( short Index );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'FindFirst(LPCTSTR)'
	short FindFirst( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'FindNext(short,LPCTSTR)'
	short FindNext( short iCurID, LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'IndexOf(LPDISPATCH)'
	short IndexOf( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'AddCollection(LPDISPATCH)'
	void AddCollection( LPDISPATCH theCollection );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'Remove(LPDISPATCH)'
	void Remove( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'RemoveAll()'
	void RemoveAll( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'GetFirst(LPCTSTR)'
	LPDISPATCH GetFirst( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'Exists(LPDISPATCH)'
	BOOL Exists( LPDISPATCH pObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInCollection' operation 'GetWithUniqueID(LPCTSTR)'
	LPDISPATCH GetWithUniqueID( LPCTSTR UniqueID );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::AddInCollection' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* AddInCollection_H */

// }}}RME
