// {{{RME classifier 'Logical View::RRTEI::AssociationCollection'

#ifndef AssociationCollection_H
#define AssociationCollection_H

#ifdef PRAGMA
#pragma interface "AssociationCollection.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class AssociationCollection : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~AssociationCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	AssociationCollection & operator=( const AssociationCollection & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'AssociationCollection()'
	AssociationCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'AssociationCollection(LPDISPATCH)'
	AssociationCollection( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'AssociationCollection(const AssociationCollection&)'
	AssociationCollection( const AssociationCollection & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'Add(LPDISPATCH)'
	void Add( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'GetCount()'
	short GetCount( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'GetAt(short)'
	LPDISPATCH GetAt( short Index );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'FindFirst(LPCTSTR)'
	short FindFirst( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'FindNext(short,LPCTSTR)'
	short FindNext( short iCurID, LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'IndexOf(LPDISPATCH)'
	short IndexOf( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'AddCollection(LPDISPATCH)'
	void AddCollection( LPDISPATCH theCollection );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'Remove(LPDISPATCH)'
	void Remove( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'RemoveAll()'
	void RemoveAll( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'GetFirst(LPCTSTR)'
	LPDISPATCH GetFirst( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'Exists(LPDISPATCH)'
	BOOL Exists( LPDISPATCH pObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' operation 'GetWithUniqueID(LPCTSTR)'
	LPDISPATCH GetWithUniqueID( LPCTSTR UniqueID );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::AssociationCollection' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* AssociationCollection_H */

// }}}RME
