// {{{RME classifier 'Logical View::RRTEI::AssociationEnd'

#ifndef AssociationEnd_H
#define AssociationEnd_H

#ifdef PRAGMA
#pragma interface "AssociationEnd.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class AssociationEnd : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~AssociationEnd( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	AssociationEnd & operator=( const AssociationEnd & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'AssociationEnd()'
	AssociationEnd( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'AssociationEnd(LPDISPATCH)'
	AssociationEnd( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'AssociationEnd(const AssociationEnd&)'
	AssociationEnd( const AssociationEnd & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetVersion()'
	CString GetVersion( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'Save()'
	BOOL Save( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsSameInstance(LPDISPATCH)'
	BOOL IsSameInstance( LPDISPATCH Other );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetName()'
	CString GetName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetToolNames()'
	LPDISPATCH GetToolNames( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'SetName(LPCTSTR)'
	void SetName( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetApplication()'
	LPDISPATCH GetApplication( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetModel()'
	LPDISPATCH GetModel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetDocumentation()'
	CString GetDocumentation( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'SetDocumentation(LPCTSTR)'
	void SetDocumentation( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetStereotype()'
	CString GetStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'SetStereotype(LPCTSTR)'
	void SetStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetLocalizedStereotype()'
	CString GetLocalizedStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'SetLocalizedStereotype(LPCTSTR)'
	void SetLocalizedStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetExternalDocuments()'
	LPDISPATCH GetExternalDocuments( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetVisibility()'
	LPDISPATCH GetVisibility( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetMultiplicity()'
	CString GetMultiplicity( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'SetMultiplicity(LPCTSTR)'
	void SetMultiplicity( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetControlNewUnits()'
	BOOL GetControlNewUnits( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'SetControlNewUnits(BOOL)'
	void SetControlNewUnits( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetUniqueID()'
	CString GetUniqueID( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetQualifiedName()'
	CString GetQualifiedName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetCurrentPropertySetName(LPCTSTR)'
	CString GetCurrentPropertySetName( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'OverrideProperty(LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL OverrideProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'InheritProperty(LPCTSTR,LPCTSTR)'
	BOOL InheritProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'CreateProperty(LPCTSTR,LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL CreateProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetDefaultPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetDefaultPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'FindProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetAllProperties()'
	LPDISPATCH GetAllProperties( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetToolProperties(LPCTSTR)'
	LPDISPATCH GetToolProperties( LPCTSTR theToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsOverriddenProperty(LPCTSTR,LPCTSTR)'
	BOOL IsOverriddenProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsDefaultProperty(LPCTSTR,LPCTSTR)'
	BOOL IsDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'FindDefaultProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetPropertyClassName()'
	CString GetPropertyClassName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetDefaultSetNames(LPCTSTR)'
	LPDISPATCH GetDefaultSetNames( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'SetCurrentPropertySetName(LPCTSTR,LPCTSTR)'
	BOOL SetCurrentPropertySetName( LPCTSTR ToolName, LPCTSTR SetName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsControlled()'
	BOOL IsControlled( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsModified()'
	BOOL IsModified( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsModifiable()'
	BOOL IsModifiable( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetFileName()'
	CString GetFileName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetContainingControlledElement()'
	LPDISPATCH GetContainingControlledElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetControlledChildElements(BOOL)'
	LPDISPATCH GetControlledChildElements( BOOL bRecursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsOwned()'
	BOOL IsOwned( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsUnderSourceControl()'
	BOOL IsUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsCheckedOut()'
	BOOL IsCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsLoaded()'
	BOOL IsLoaded( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'Uncontrol()'
	BOOL Uncontrol( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'ControlChildElements(BOOL)'
	BOOL ControlChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'UncontrolChildElements(BOOL)'
	BOOL UncontrolChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'ControlTo(LPCTSTR)'
	BOOL ControlTo( LPCTSTR Path );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'Control()'
	BOOL Control( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsChildDirUnderSourceControl()'
	BOOL IsChildDirUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsControllableElementContainer()'
	BOOL IsControllableElementContainer( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsChildDirCheckedOut()'
	BOOL IsChildDirCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetChildDirName()'
	CString GetChildDirName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsScratchPad()'
	BOOL IsScratchPad( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetModelElement()'
	LPDISPATCH GetModelElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'DeleteExternalDocument(LPDISPATCH)'
	BOOL DeleteExternalDocument( LPDISPATCH pIDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'AddExternalDocument(LPCTSTR,long)'
	LPDISPATCH AddExternalDocument( LPCTSTR szName, long iType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'OpenSpecification()'
	BOOL OpenSpecification( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetClassifier()'
	LPDISPATCH GetClassifier( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetSupplierName()'
	CString GetSupplierName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'SetSupplierName(LPCTSTR)'
	void SetSupplierName( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'HasClient()'
	BOOL HasClient( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'HasSupplier()'
	BOOL HasSupplier( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetClient()'
	LPDISPATCH GetClient( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetSupplier()'
	LPDISPATCH GetSupplier( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetAggregate()'
	BOOL GetAggregate( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'SetAggregate(BOOL)'
	void SetAggregate( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetStatic()'
	BOOL GetStatic( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'SetStatic(BOOL)'
	void SetStatic( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetFriend()'
	BOOL GetFriend( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'SetFriend(BOOL)'
	void SetFriend( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetNavigable()'
	BOOL GetNavigable( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'SetNavigable(BOOL)'
	void SetNavigable( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetContainment()'
	LPDISPATCH GetContainment( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetAssociation()'
	LPDISPATCH GetAssociation( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetKeys()'
	LPDISPATCH GetKeys( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetAssociateModelElement()'
	LPDISPATCH GetAssociateModelElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetUseCase()'
	LPDISPATCH GetUseCase( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetConstraints()'
	CString GetConstraints( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'SetConstraints(LPCTSTR)'
	void SetConstraints( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'AddKey(LPCTSTR,LPCTSTR)'
	LPDISPATCH AddKey( LPCTSTR theName, LPCTSTR theType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'DeleteKey(LPDISPATCH)'
	BOOL DeleteKey( LPDISPATCH theAttr );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'GetClassName()'
	CString GetClassName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' operation 'IsAssociateClass()'
	BOOL IsAssociateClass( void );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::AssociationEnd' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* AssociationEnd_H */

// }}}RME
