// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection'

#ifndef AssociationEndCollection_H
#define AssociationEndCollection_H

#ifdef PRAGMA
#pragma interface "AssociationEndCollection.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class AssociationEndCollection : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~AssociationEndCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	AssociationEndCollection & operator=( const AssociationEndCollection & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'AssociationEndCollection()'
	AssociationEndCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'AssociationEndCollection(LPDISPATCH)'
	AssociationEndCollection( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'AssociationEndCollection(const AssociationEndCollection&)'
	AssociationEndCollection( const AssociationEndCollection & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'Add(LPDISPATCH)'
	void Add( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'GetCount()'
	short GetCount( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'GetAt(short)'
	LPDISPATCH GetAt( short Index );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'FindFirst(LPCTSTR)'
	short FindFirst( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'FindNext(short,LPCTSTR)'
	short FindNext( short iCurID, LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'IndexOf(LPDISPATCH)'
	short IndexOf( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'AddCollection(LPDISPATCH)'
	void AddCollection( LPDISPATCH theCollection );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'Remove(LPDISPATCH)'
	void Remove( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'RemoveAll()'
	void RemoveAll( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'GetFirst(LPCTSTR)'
	LPDISPATCH GetFirst( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'Exists(LPDISPATCH)'
	BOOL Exists( LPDISPATCH pObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' operation 'GetWithUniqueID(LPCTSTR)'
	LPDISPATCH GetWithUniqueID( LPCTSTR UniqueID );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::AssociationEndCollection' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* AssociationEndCollection_H */

// }}}RME
