// {{{RME classifier 'Logical View::RRTEI::AttributeCollection'

#ifndef AttributeCollection_H
#define AttributeCollection_H

#ifdef PRAGMA
#pragma interface "AttributeCollection.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class AttributeCollection : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~AttributeCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	AttributeCollection & operator=( const AttributeCollection & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'AttributeCollection()'
	AttributeCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'AttributeCollection(LPDISPATCH)'
	AttributeCollection( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'AttributeCollection(const AttributeCollection&)'
	AttributeCollection( const AttributeCollection & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'Add(LPDISPATCH)'
	void Add( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'GetCount()'
	short GetCount( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'GetAt(short)'
	LPDISPATCH GetAt( short Index );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'FindFirst(LPCTSTR)'
	short FindFirst( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'FindNext(short,LPCTSTR)'
	short FindNext( short iCurID, LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'IndexOf(LPDISPATCH)'
	short IndexOf( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'AddCollection(LPDISPATCH)'
	void AddCollection( LPDISPATCH theCollection );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'Remove(LPDISPATCH)'
	void Remove( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'RemoveAll()'
	void RemoveAll( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'GetFirst(LPCTSTR)'
	LPDISPATCH GetFirst( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'Exists(LPDISPATCH)'
	BOOL Exists( LPDISPATCH pObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' operation 'GetWithUniqueID(LPCTSTR)'
	LPDISPATCH GetWithUniqueID( LPCTSTR UniqueID );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::AttributeCollection' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* AttributeCollection_H */

// }}}RME
