// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection'

#ifndef ClassDependencyCollection_H
#define ClassDependencyCollection_H

#ifdef PRAGMA
#pragma interface "ClassDependencyCollection.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class ClassDependencyCollection : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~ClassDependencyCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	ClassDependencyCollection & operator=( const ClassDependencyCollection & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'ClassDependencyCollection()'
	ClassDependencyCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'ClassDependencyCollection(LPDISPATCH)'
	ClassDependencyCollection( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'ClassDependencyCollection(const ClassDependencyCollection&)'
	ClassDependencyCollection( const ClassDependencyCollection & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'Add(LPDISPATCH)'
	void Add( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'GetCount()'
	short GetCount( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'GetAt(short)'
	LPDISPATCH GetAt( short Index );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'FindFirst(LPCTSTR)'
	short FindFirst( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'FindNext(short,LPCTSTR)'
	short FindNext( short iCurID, LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'IndexOf(LPDISPATCH)'
	short IndexOf( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'AddCollection(LPDISPATCH)'
	void AddCollection( LPDISPATCH theCollection );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'Remove(LPDISPATCH)'
	void Remove( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'RemoveAll()'
	void RemoveAll( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'GetFirst(LPCTSTR)'
	LPDISPATCH GetFirst( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'Exists(LPDISPATCH)'
	BOOL Exists( LPDISPATCH pObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' operation 'GetWithUniqueID(LPCTSTR)'
	LPDISPATCH GetWithUniqueID( LPCTSTR UniqueID );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::ClassDependencyCollection' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* ClassDependencyCollection_H */

// }}}RME
