// {{{RME classifier 'Logical View::RRTEI::ClassDiagram'

#ifndef ClassDiagram_H
#define ClassDiagram_H

#ifdef PRAGMA
#pragma interface "ClassDiagram.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class ClassDiagram : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~ClassDiagram( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	ClassDiagram & operator=( const ClassDiagram & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'ClassDiagram()'
	ClassDiagram( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'ClassDiagram(LPDISPATCH)'
	ClassDiagram( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'ClassDiagram(const ClassDiagram&)'
	ClassDiagram( const ClassDiagram & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetVisible()'
	BOOL GetVisible( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'SetVisible(BOOL)'
	void SetVisible( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetVersion()'
	CString GetVersion( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'Save()'
	BOOL Save( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsSameInstance(LPDISPATCH)'
	BOOL IsSameInstance( LPDISPATCH Other );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'Exists(LPDISPATCH)'
	BOOL Exists( LPDISPATCH theModelElement );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetName()'
	CString GetName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetToolNames()'
	LPDISPATCH GetToolNames( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'Activate()'
	void Activate( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsActive()'
	BOOL IsActive( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'SetName(LPCTSTR)'
	void SetName( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetApplication()'
	LPDISPATCH GetApplication( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetModel()'
	LPDISPATCH GetModel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetDocumentation()'
	CString GetDocumentation( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'SetDocumentation(LPCTSTR)'
	void SetDocumentation( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetExternalDocuments()'
	LPDISPATCH GetExternalDocuments( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetParentLogicalPackage()'
	LPDISPATCH GetParentLogicalPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetControlNewUnits()'
	BOOL GetControlNewUnits( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'SetControlNewUnits(BOOL)'
	void SetControlNewUnits( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetUniqueID()'
	CString GetUniqueID( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetQualifiedName()'
	CString GetQualifiedName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetCurrentPropertySetName(LPCTSTR)'
	CString GetCurrentPropertySetName( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'OverrideProperty(LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL OverrideProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'InheritProperty(LPCTSTR,LPCTSTR)'
	BOOL InheritProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'CreateProperty(LPCTSTR,LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL CreateProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetDefaultPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetDefaultPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'FindProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetAllProperties()'
	LPDISPATCH GetAllProperties( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetToolProperties(LPCTSTR)'
	LPDISPATCH GetToolProperties( LPCTSTR theToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsOverriddenProperty(LPCTSTR,LPCTSTR)'
	BOOL IsOverriddenProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsDefaultProperty(LPCTSTR,LPCTSTR)'
	BOOL IsDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'FindDefaultProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetPropertyClassName()'
	CString GetPropertyClassName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetDefaultSetNames(LPCTSTR)'
	LPDISPATCH GetDefaultSetNames( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'SetCurrentPropertySetName(LPCTSTR,LPCTSTR)'
	BOOL SetCurrentPropertySetName( LPCTSTR ToolName, LPCTSTR SetName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsControlled()'
	BOOL IsControlled( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsModified()'
	BOOL IsModified( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsModifiable()'
	BOOL IsModifiable( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetFileName()'
	CString GetFileName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetContainingControlledElement()'
	LPDISPATCH GetContainingControlledElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetControlledChildElements(BOOL)'
	LPDISPATCH GetControlledChildElements( BOOL bRecursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsOwned()'
	BOOL IsOwned( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsUnderSourceControl()'
	BOOL IsUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsCheckedOut()'
	BOOL IsCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsLoaded()'
	BOOL IsLoaded( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'Uncontrol()'
	BOOL Uncontrol( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'ControlChildElements(BOOL)'
	BOOL ControlChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'UncontrolChildElements(BOOL)'
	BOOL UncontrolChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'ControlTo(LPCTSTR)'
	BOOL ControlTo( LPCTSTR Path );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'Control()'
	BOOL Control( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsChildDirUnderSourceControl()'
	BOOL IsChildDirUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsControllableElementContainer()'
	BOOL IsControllableElementContainer( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsChildDirCheckedOut()'
	BOOL IsChildDirCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetChildDirName()'
	CString GetChildDirName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsScratchPad()'
	BOOL IsScratchPad( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'DeleteExternalDocument(LPDISPATCH)'
	BOOL DeleteExternalDocument( LPDISPATCH theExtDoc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'AddExternalDocument(LPCTSTR,long)'
	LPDISPATCH AddExternalDocument( LPCTSTR szName, long iType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetAssociations()'
	LPDISPATCH GetAssociations( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'AddAssociation(LPDISPATCH)'
	BOOL AddAssociation( LPDISPATCH theAssociation );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetUseCases()'
	LPDISPATCH GetUseCases( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetSelectedClasses()'
	LPDISPATCH GetSelectedClasses( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetSelectedLogicalPackages()'
	LPDISPATCH GetSelectedLogicalPackages( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetSelectedModelElements()'
	LPDISPATCH GetSelectedModelElements( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetSelectedCapsules()'
	LPDISPATCH GetSelectedCapsules( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetSelectedProtocols()'
	LPDISPATCH GetSelectedProtocols( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetClasses()'
	LPDISPATCH GetClasses( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetLogicalPackages()'
	LPDISPATCH GetLogicalPackages( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetCapsules()'
	LPDISPATCH GetCapsules( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetProtocols()'
	LPDISPATCH GetProtocols( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'AddClass(LPDISPATCH)'
	BOOL AddClass( LPDISPATCH theClass );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'AddLogicalPackage(LPDISPATCH)'
	BOOL AddLogicalPackage( LPDISPATCH theCat );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'AddUseCase(LPDISPATCH)'
	BOOL AddUseCase( LPDISPATCH theUseCase );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'AddCapsule(LPDISPATCH)'
	BOOL AddCapsule( LPDISPATCH theCapsule );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'AddProtocol(LPDISPATCH)'
	BOOL AddProtocol( LPDISPATCH theProtocol );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetViewElements()'
	LPDISPATCH GetViewElements( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetModelElements()'
	LPDISPATCH GetModelElements( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetParentModelElement()'
	LPDISPATCH GetParentModelElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetZoomFactor()'
	short GetZoomFactor( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'SetZoomFactor(short)'
	void SetZoomFactor( short propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'Layout()'
	void Layout( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'Invalidate()'
	void Invalidate( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'Update()'
	void Update( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetViewFrom(LPDISPATCH)'
	LPDISPATCH GetViewFrom( LPDISPATCH theModelElement );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'Render(LPCTSTR)'
	void Render( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetNoteViews()'
	LPDISPATCH GetNoteViews( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'RenderEnhanced(LPCTSTR)'
	void RenderEnhanced( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'RenderToClipboard()'
	void RenderToClipboard( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'RenderEnhancedToClipboard()'
	void RenderEnhancedToClipboard( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'AddAnchorNoteView(LPDISPATCH,LPDISPATCH)'
	LPDISPATCH AddAnchorNoteView( LPDISPATCH FromView, LPDISPATCH ToView );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'RemoveAnchorNoteView(LPDISPATCH)'
	BOOL RemoveAnchorNoteView( LPDISPATCH AnchorNoteView );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'AddNoteView(LPCTSTR,long)'
	LPDISPATCH AddNoteView( LPCTSTR szNoteText, long nType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'RemoveNoteView(LPDISPATCH)'
	BOOL RemoveNoteView( LPDISPATCH pIDispNoteView );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'RemoveClass(LPDISPATCH)'
	BOOL RemoveClass( LPDISPATCH theClass );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'RemoveLogicalPackage(LPDISPATCH)'
	BOOL RemoveLogicalPackage( LPDISPATCH theLogicalPackage );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'RemoveAssociation(LPDISPATCH)'
	BOOL RemoveAssociation( LPDISPATCH theAssociation );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'RemoveUseCase(LPDISPATCH)'
	BOOL RemoveUseCase( LPDISPATCH theUseCase );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'IsUseCaseDiagram()'
	BOOL IsUseCaseDiagram( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetClassView(LPDISPATCH)'
	LPDISPATCH GetClassView( LPDISPATCH theClass );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'RemoveCapsule(LPDISPATCH)'
	BOOL RemoveCapsule( LPDISPATCH theCapsule );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'RemoveProtocol(LPDISPATCH)'
	BOOL RemoveProtocol( LPDISPATCH theProtocol );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetCapsuleView(LPDISPATCH)'
	LPDISPATCH GetCapsuleView( LPDISPATCH theCapsule );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' operation 'GetProtocolView(LPDISPATCH)'
	LPDISPATCH GetProtocolView( LPDISPATCH theProtocol );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::ClassDiagram' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* ClassDiagram_H */

// }}}RME
