// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem'

#ifndef ContextMenuItem_H
#define ContextMenuItem_H

#ifdef PRAGMA
#pragma interface "ContextMenuItem.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class ContextMenuItem : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~ContextMenuItem( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	ContextMenuItem & operator=( const ContextMenuItem & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' operation 'ContextMenuItem()'
	ContextMenuItem( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' operation 'ContextMenuItem(LPDISPATCH)'
	ContextMenuItem( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' operation 'ContextMenuItem(const ContextMenuItem&)'
	ContextMenuItem( const ContextMenuItem & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' operation 'IsSameInstance(LPDISPATCH)'
	BOOL IsSameInstance( LPDISPATCH Other );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' operation 'GetCaption()'
	CString GetCaption( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' operation 'GetInternalName()'
	CString GetInternalName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' operation 'SetInternalName(LPCTSTR)'
	void SetInternalName( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' operation 'GetMenuID()'
	short GetMenuID( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' operation 'GetMenuState()'
	LPDISPATCH GetMenuState( void );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::ContextMenuItem' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* ContextMenuItem_H */

// }}}RME
