// {{{RME classifier 'Logical View::RRTEI::Model'

#ifndef Model_H
#define Model_H

#ifdef PRAGMA
#pragma interface "Model.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::Model' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class Model : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::Model' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::Model' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::Model' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::Model' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~Model( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	Model & operator=( const Model & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'Model()'
	Model( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'Model(LPDISPATCH)'
	Model( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'Model(const Model&)'
	Model( const Model & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetVersion()'
	CString GetVersion( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'Save()'
	BOOL Save( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsSameInstance(LPDISPATCH)'
	BOOL IsSameInstance( LPDISPATCH Other );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetName()'
	CString GetName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetToolNames()'
	LPDISPATCH GetToolNames( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'SetName(LPCTSTR)'
	void SetName( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetApplication()'
	LPDISPATCH GetApplication( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetModel()'
	LPDISPATCH GetModel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetDocumentation()'
	CString GetDocumentation( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'SetDocumentation(LPCTSTR)'
	void SetDocumentation( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetStereotype()'
	CString GetStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'SetStereotype(LPCTSTR)'
	void SetStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetLocalizedStereotype()'
	CString GetLocalizedStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'SetLocalizedStereotype(LPCTSTR)'
	void SetLocalizedStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetExternalDocuments()'
	LPDISPATCH GetExternalDocuments( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetControlNewUnits()'
	BOOL GetControlNewUnits( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'SetControlNewUnits(BOOL)'
	void SetControlNewUnits( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetUniqueID()'
	CString GetUniqueID( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetQualifiedName()'
	CString GetQualifiedName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetCurrentPropertySetName(LPCTSTR)'
	CString GetCurrentPropertySetName( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'OverrideProperty(LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL OverrideProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'InheritProperty(LPCTSTR,LPCTSTR)'
	BOOL InheritProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'CreateProperty(LPCTSTR,LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL CreateProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetDefaultPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetDefaultPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'FindProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetAllProperties()'
	LPDISPATCH GetAllProperties( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetToolProperties(LPCTSTR)'
	LPDISPATCH GetToolProperties( LPCTSTR theToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsOverriddenProperty(LPCTSTR,LPCTSTR)'
	BOOL IsOverriddenProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsDefaultProperty(LPCTSTR,LPCTSTR)'
	BOOL IsDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'FindDefaultProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetPropertyClassName()'
	CString GetPropertyClassName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetDefaultSetNames(LPCTSTR)'
	LPDISPATCH GetDefaultSetNames( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'SetCurrentPropertySetName(LPCTSTR,LPCTSTR)'
	BOOL SetCurrentPropertySetName( LPCTSTR ToolName, LPCTSTR SetName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsControlled()'
	BOOL IsControlled( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsModified()'
	BOOL IsModified( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsModifiable()'
	BOOL IsModifiable( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetFileName()'
	CString GetFileName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetContainingControlledElement()'
	LPDISPATCH GetContainingControlledElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetControlledChildElements(BOOL)'
	LPDISPATCH GetControlledChildElements( BOOL bRecursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsOwned()'
	BOOL IsOwned( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsUnderSourceControl()'
	BOOL IsUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsCheckedOut()'
	BOOL IsCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsLoaded()'
	BOOL IsLoaded( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'Uncontrol()'
	BOOL Uncontrol( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'ControlChildElements(BOOL)'
	BOOL ControlChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'UncontrolChildElements(BOOL)'
	BOOL UncontrolChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'ControlTo(LPCTSTR)'
	BOOL ControlTo( LPCTSTR Path );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'Control()'
	BOOL Control( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsChildDirUnderSourceControl()'
	BOOL IsChildDirUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsControllableElementContainer()'
	BOOL IsControllableElementContainer( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsChildDirCheckedOut()'
	BOOL IsChildDirCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetChildDirName()'
	CString GetChildDirName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsScratchPad()'
	BOOL IsScratchPad( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetModelElement()'
	LPDISPATCH GetModelElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'DeleteExternalDocument(LPDISPATCH)'
	BOOL DeleteExternalDocument( LPDISPATCH pIDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'AddExternalDocument(LPCTSTR,long)'
	LPDISPATCH AddExternalDocument( LPCTSTR szName, long iType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'OpenSpecification()'
	BOOL OpenSpecification( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetRootLogicalPackage()'
	LPDISPATCH GetRootLogicalPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetRootComponentPackage()'
	LPDISPATCH GetRootComponentPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetDeploymentDiagram()'
	LPDISPATCH GetDeploymentDiagram( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetUseCases()'
	LPDISPATCH GetUseCases( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetRootUseCaseLogicalPackage()'
	LPDISPATCH GetRootUseCaseLogicalPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetDefaultProperties()'
	LPDISPATCH GetDefaultProperties( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetRootDeploymentPackage()'
	LPDISPATCH GetRootDeploymentPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetActiveComponent()'
	LPDISPATCH GetActiveComponent( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'SetActiveComponent(LPDISPATCH)'
	void SetActiveComponent( LPDISPATCH propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'IsRootPackage()'
	BOOL IsRootPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'ImportFile(LPCTSTR)'
	BOOL ImportFile( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'AddUnit(LPCTSTR)'
	BOOL AddUnit( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'AddSharedUnit(LPCTSTR)'
	BOOL AddSharedUnit( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'ImportFileEx(LPCTSTR)'
	LPDISPATCH ImportFileEx( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'TopLevel()'
	BOOL TopLevel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'AddProcessor(LPCTSTR)'
	LPDISPATCH AddProcessor( LPCTSTR pName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetActiveDiagram()'
	LPDISPATCH GetActiveDiagram( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'DeleteProcessor(LPDISPATCH)'
	BOOL DeleteProcessor( LPDISPATCH pProcessor );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'AddDevice(LPCTSTR)'
	LPDISPATCH AddDevice( LPCTSTR pName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'DeleteDevice(LPDISPATCH)'
	BOOL DeleteDevice( LPDISPATCH pDevice );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetSelectedClasses()'
	LPDISPATCH GetSelectedClasses( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetSelectedLogicalPackages()'
	LPDISPATCH GetSelectedLogicalPackages( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetSelectedComponents()'
	LPDISPATCH GetSelectedComponents( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetSelectedComponentPackages()'
	LPDISPATCH GetSelectedComponentPackages( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetAllClasses()'
	LPDISPATCH GetAllClasses( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetAllLogicalPackages()'
	LPDISPATCH GetAllLogicalPackages( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetAllComponents()'
	LPDISPATCH GetAllComponents( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetAllComponentPackages()'
	LPDISPATCH GetAllComponentPackages( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetAllProcessors()'
	LPDISPATCH GetAllProcessors( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetAllDevices()'
	LPDISPATCH GetAllDevices( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetSelectedUseCases()'
	LPDISPATCH GetSelectedUseCases( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetAllUseCases()'
	LPDISPATCH GetAllUseCases( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetAllAssociations()'
	LPDISPATCH GetAllAssociations( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'FindModelElements(LPCTSTR)'
	LPDISPATCH FindModelElements( LPCTSTR ModelElementName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'FindModelElementWithID(LPCTSTR)'
	LPDISPATCH FindModelElementWithID( LPCTSTR UniqueID );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'FindClasses(LPCTSTR)'
	LPDISPATCH FindClasses( LPCTSTR ClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'FindClassWithID(LPCTSTR)'
	LPDISPATCH FindClassWithID( LPCTSTR UniqueID );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'FindLogicalPackages(LPCTSTR)'
	LPDISPATCH FindLogicalPackages( LPCTSTR LogicalPackageName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'FindLogicalPackageWithID(LPCTSTR)'
	LPDISPATCH FindLogicalPackageWithID( LPCTSTR UniqueID );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'ControlAllUnits(BOOL)'
	BOOL ControlAllUnits( BOOL bControlAllUnits );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetAllCapsules()'
	LPDISPATCH GetAllCapsules( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetAllProtocols()'
	LPDISPATCH GetAllProtocols( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'FindCapsules(LPCTSTR)'
	LPDISPATCH FindCapsules( LPCTSTR capsuleName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'FindProtocols(LPCTSTR)'
	LPDISPATCH FindProtocols( LPCTSTR protocolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetSelectedModelElements()'
	LPDISPATCH GetSelectedModelElements( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetActiveComponentInstances()'
	LPDISPATCH GetActiveComponentInstances( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'AddActiveComponentInstance(LPDISPATCH)'
	BOOL AddActiveComponentInstance( LPDISPATCH ComponentInstanceToAdd );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'RemoveActiveComponentInstance(LPDISPATCH)'
	BOOL RemoveActiveComponentInstance( LPDISPATCH ComponentInstanceToRemove );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'FindCapsuleWithID(LPCTSTR)'
	LPDISPATCH FindCapsuleWithID( LPCTSTR UniqueID );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'FindProtocolWithID(LPCTSTR)'
	LPDISPATCH FindProtocolWithID( LPCTSTR UniqueID );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetSelectedCapsules()'
	LPDISPATCH GetSelectedCapsules( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Model' operation 'GetSelectedProtocols()'
	LPDISPATCH GetSelectedProtocols( void );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::Model' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* Model_H */

// }}}RME
