// {{{RME classifier 'Logical View::RRTEI::Processor'

#ifndef Processor_H
#define Processor_H

#ifdef PRAGMA
#pragma interface "Processor.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::Processor' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class Processor : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::Processor' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::Processor' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::Processor' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::Processor' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~Processor( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	Processor & operator=( const Processor & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'Processor()'
	Processor( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'Processor(LPDISPATCH)'
	Processor( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'Processor(const Processor&)'
	Processor( const Processor & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetVersion()'
	CString GetVersion( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'Save()'
	BOOL Save( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsSameInstance(LPDISPATCH)'
	BOOL IsSameInstance( LPDISPATCH Other );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetName()'
	CString GetName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetToolNames()'
	LPDISPATCH GetToolNames( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'SetName(LPCTSTR)'
	void SetName( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetApplication()'
	LPDISPATCH GetApplication( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetModel()'
	LPDISPATCH GetModel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetDocumentation()'
	CString GetDocumentation( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'SetDocumentation(LPCTSTR)'
	void SetDocumentation( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetStereotype()'
	CString GetStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'SetStereotype(LPCTSTR)'
	void SetStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetLocalizedStereotype()'
	CString GetLocalizedStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'SetLocalizedStereotype(LPCTSTR)'
	void SetLocalizedStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetExternalDocuments()'
	LPDISPATCH GetExternalDocuments( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetControlNewUnits()'
	BOOL GetControlNewUnits( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'SetControlNewUnits(BOOL)'
	void SetControlNewUnits( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetUniqueID()'
	CString GetUniqueID( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetQualifiedName()'
	CString GetQualifiedName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetCurrentPropertySetName(LPCTSTR)'
	CString GetCurrentPropertySetName( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'OverrideProperty(LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL OverrideProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'InheritProperty(LPCTSTR,LPCTSTR)'
	BOOL InheritProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'CreateProperty(LPCTSTR,LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL CreateProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetDefaultPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetDefaultPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'FindProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetAllProperties()'
	LPDISPATCH GetAllProperties( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetToolProperties(LPCTSTR)'
	LPDISPATCH GetToolProperties( LPCTSTR theToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsOverriddenProperty(LPCTSTR,LPCTSTR)'
	BOOL IsOverriddenProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsDefaultProperty(LPCTSTR,LPCTSTR)'
	BOOL IsDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'FindDefaultProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetPropertyClassName()'
	CString GetPropertyClassName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetDefaultSetNames(LPCTSTR)'
	LPDISPATCH GetDefaultSetNames( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'SetCurrentPropertySetName(LPCTSTR,LPCTSTR)'
	BOOL SetCurrentPropertySetName( LPCTSTR ToolName, LPCTSTR SetName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsControlled()'
	BOOL IsControlled( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsModified()'
	BOOL IsModified( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsModifiable()'
	BOOL IsModifiable( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetFileName()'
	CString GetFileName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetContainingControlledElement()'
	LPDISPATCH GetContainingControlledElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetControlledChildElements(BOOL)'
	LPDISPATCH GetControlledChildElements( BOOL bRecursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsOwned()'
	BOOL IsOwned( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsUnderSourceControl()'
	BOOL IsUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsCheckedOut()'
	BOOL IsCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsLoaded()'
	BOOL IsLoaded( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'Uncontrol()'
	BOOL Uncontrol( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'ControlChildElements(BOOL)'
	BOOL ControlChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'UncontrolChildElements(BOOL)'
	BOOL UncontrolChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'ControlTo(LPCTSTR)'
	BOOL ControlTo( LPCTSTR Path );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'Control()'
	BOOL Control( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsChildDirUnderSourceControl()'
	BOOL IsChildDirUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsControllableElementContainer()'
	BOOL IsControllableElementContainer( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsChildDirCheckedOut()'
	BOOL IsChildDirCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetChildDirName()'
	CString GetChildDirName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'IsScratchPad()'
	BOOL IsScratchPad( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetModelElement()'
	LPDISPATCH GetModelElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'DeleteExternalDocument(LPDISPATCH)'
	BOOL DeleteExternalDocument( LPDISPATCH pIDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'AddExternalDocument(LPCTSTR,long)'
	LPDISPATCH AddExternalDocument( LPCTSTR szName, long iType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'OpenSpecification()'
	BOOL OpenSpecification( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetParentDeploymentPackage()'
	LPDISPATCH GetParentDeploymentPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetComponentInstances()'
	LPDISPATCH GetComponentInstances( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetOs()'
	CString GetOs( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'SetOs(LPCTSTR)'
	void SetOs( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetCpu()'
	CString GetCpu( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'SetCpu(LPCTSTR)'
	void SetCpu( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetAddress()'
	CString GetAddress( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'SetAddress(LPCTSTR)'
	void SetAddress( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetUserScriptDirectory()'
	CString GetUserScriptDirectory( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'SetUserScriptDirectory(LPCTSTR)'
	void SetUserScriptDirectory( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetServerAddress()'
	CString GetServerAddress( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'SetServerAddress(LPCTSTR)'
	void SetServerAddress( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetConnectedDevices()'
	LPDISPATCH GetConnectedDevices( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'GetConnectedProcessors()'
	LPDISPATCH GetConnectedProcessors( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'AddComponentInstance(LPCTSTR)'
	LPDISPATCH AddComponentInstance( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'DeleteComponentInstance(LPDISPATCH)'
	BOOL DeleteComponentInstance( LPDISPATCH theComponentInstance );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'AddProcessorConnection(LPDISPATCH)'
	BOOL AddProcessorConnection( LPDISPATCH Processor );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'RemoveProcessorConnection(LPDISPATCH)'
	BOOL RemoveProcessorConnection( LPDISPATCH theProcessor );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'AddDeviceConnection(LPDISPATCH)'
	BOOL AddDeviceConnection( LPDISPATCH theDevice );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Processor' operation 'RemoveDeviceConnection(LPDISPATCH)'
	BOOL RemoveDeviceConnection( LPDISPATCH theDevice );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::Processor' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* Processor_H */

// }}}RME
