// {{{RME classifier 'Logical View::RRTEI::Property'

#ifndef Property_H
#define Property_H

#ifdef PRAGMA
#pragma interface "Property.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::Property' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class Property : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::Property' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::Property' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::Property' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::Property' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~Property( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Property' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	Property & operator=( const Property & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Property' operation 'Property()'
	Property( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Property' operation 'Property(LPDISPATCH)'
	Property( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Property' operation 'Property(const Property&)'
	Property( const Property & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Property' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Property' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Property' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Property' operation 'IsSameInstance(LPDISPATCH)'
	BOOL IsSameInstance( LPDISPATCH Other );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Property' operation 'GetName()'
	CString GetName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Property' operation 'SetName(LPCTSTR)'
	void SetName( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Property' operation 'GetValue()'
	CString GetValue( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Property' operation 'SetValue(LPCTSTR)'
	void SetValue( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Property' operation 'GetToolName()'
	CString GetToolName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Property' operation 'GetType()'
	CString GetType( void );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::Property' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* Property_H */

// }}}RME
