// {{{RME classifier 'Logical View::RRTEI::RichType'

#ifndef RichType_H
#define RichType_H

#ifdef PRAGMA
#pragma interface "RichType.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::RichType' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class RichType : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::RichType' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::RichType' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::RichType' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::RichType' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~RichType( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::RichType' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	RichType & operator=( const RichType & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::RichType' operation 'RichType()'
	RichType( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::RichType' operation 'RichType(LPDISPATCH)'
	RichType( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::RichType' operation 'RichType(const RichType&)'
	RichType( const RichType & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::RichType' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::RichType' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::RichType' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::RichType' operation 'GetName()'
	CString GetName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::RichType' operation 'SetName(LPCTSTR)'
	void SetName( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::RichType' operation 'GetValue()'
	short GetValue( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::RichType' operation 'SetValue(short)'
	void SetValue( short propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::RichType' operation 'GetTypes()'
	LPDISPATCH GetTypes( void );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::RichType' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* RichType_H */

// }}}RME
