// {{{RME classifier 'Logical View::RRTEI::AddIn'

#ifndef AddIn_H
#define AddIn_H

#ifdef PRAGMA
#pragma interface "AddIn.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::AddIn' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class AddIn : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::AddIn' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::AddIn' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::AddIn' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::AddIn' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~AddIn( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	AddIn & operator=( const AddIn & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'AddIn()'
	AddIn( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'AddIn(LPDISPATCH)'
	AddIn( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'AddIn(const AddIn&)'
	AddIn( const AddIn & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetVersion()'
	CString GetVersion( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'ExecuteScript(LPCTSTR)'
	void ExecuteScript( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'IsSameInstance(LPDISPATCH)'
	BOOL IsSameInstance( LPDISPATCH Other );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetEventHandler()'
	LPDISPATCH GetEventHandler( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetName()'
	CString GetName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetServerName()'
	CString GetServerName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetToolNames()'
	LPDISPATCH GetToolNames( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetFundamentalTypes()'
	LPDISPATCH GetFundamentalTypes( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetRootRegistryPath()'
	CString GetRootRegistryPath( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetInstallDirectory()'
	CString GetInstallDirectory( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetPropertyFilePath()'
	CString GetPropertyFilePath( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetMenuFilePath()'
	CString GetMenuFilePath( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetHelpFilePath()'
	CString GetHelpFilePath( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetCompanyName()'
	CString GetCompanyName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetCopyright()'
	CString GetCopyright( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'Activate()'
	void Activate( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'Deactivate()'
	void Deactivate( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'IsActive()'
	BOOL IsActive( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'IsLanguageAddIn()'
	BOOL IsLanguageAddIn( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'ReadSetting(LPCTSTR,LPCTSTR,LPCTSTR)'
	CString ReadSetting( LPCTSTR Section, LPCTSTR Entry, LPCTSTR Default );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'WriteSetting(LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL WriteSetting( LPCTSTR Section, LPCTSTR Entry, LPCTSTR Value );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'IsRTAddIn()'
	BOOL IsRTAddIn( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'GetContextMenuItemsForClass(LPCTSTR)'
	LPDISPATCH GetContextMenuItemsForClass( LPCTSTR itemType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddIn' operation 'AddContextMenuItemForClass(LPCTSTR,LPCTSTR,LPCTSTR)'
	LPDISPATCH AddContextMenuItemForClass( LPCTSTR itemType, LPCTSTR fullCaption, LPCTSTR InternalName );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::AddIn' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* AddIn_H */

// }}}RME
