// {{{RME classifier 'Logical View::RRTEI::AddInManager'

#ifndef AddInManager_H
#define AddInManager_H

#ifdef PRAGMA
#pragma interface "AddInManager.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::AddInManager' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class AddInManager : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::AddInManager' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::AddInManager' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::AddInManager' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::AddInManager' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~AddInManager( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInManager' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	AddInManager & operator=( const AddInManager & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInManager' operation 'AddInManager()'
	AddInManager( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInManager' operation 'AddInManager(LPDISPATCH)'
	AddInManager( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInManager' operation 'AddInManager(const AddInManager&)'
	AddInManager( const AddInManager & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInManager' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInManager' operation 'GetAddIns()'
	LPDISPATCH GetAddIns( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInManager' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInManager' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::AddInManager' operation 'IsSameInstance(LPDISPATCH)'
	BOOL IsSameInstance( LPDISPATCH Other );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::AddInManager' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* AddInManager_H */

// }}}RME
