// {{{RME classifier 'Logical View::RRTEI::Capsule'

#ifndef Capsule_H
#define Capsule_H

#ifdef PRAGMA
#pragma interface "Capsule.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::Capsule' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class Capsule : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::Capsule' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::Capsule' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::Capsule' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::Capsule' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~Capsule( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	Capsule & operator=( const Capsule & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'Capsule()'
	Capsule( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'Capsule(LPDISPATCH)'
	Capsule( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'Capsule(const Capsule&)'
	Capsule( const Capsule & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetVersion()'
	CString GetVersion( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'Save()'
	BOOL Save( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsSameInstance(LPDISPATCH)'
	BOOL IsSameInstance( LPDISPATCH Other );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetName()'
	CString GetName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetToolNames()'
	LPDISPATCH GetToolNames( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'SetName(LPCTSTR)'
	void SetName( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetApplication()'
	LPDISPATCH GetApplication( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetModel()'
	LPDISPATCH GetModel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetDocumentation()'
	CString GetDocumentation( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'SetDocumentation(LPCTSTR)'
	void SetDocumentation( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetStereotype()'
	CString GetStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'SetStereotype(LPCTSTR)'
	void SetStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetLocalizedStereotype()'
	CString GetLocalizedStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'SetLocalizedStereotype(LPCTSTR)'
	void SetLocalizedStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetExternalDocuments()'
	LPDISPATCH GetExternalDocuments( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetAbstract()'
	BOOL GetAbstract( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'SetAbstract(BOOL)'
	void SetAbstract( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetParentLogicalPackage()'
	LPDISPATCH GetParentLogicalPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetAttributes()'
	LPDISPATCH GetAttributes( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetOperations()'
	LPDISPATCH GetOperations( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetVisibility()'
	LPDISPATCH GetVisibility( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetStateMachine()'
	LPDISPATCH GetStateMachine( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetSystemClass()'
	BOOL GetSystemClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'SetSystemClass(BOOL)'
	void SetSystemClass( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetCollaborations()'
	LPDISPATCH GetCollaborations( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetAssignedLanguage()'
	CString GetAssignedLanguage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetControlNewUnits()'
	BOOL GetControlNewUnits( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'SetControlNewUnits(BOOL)'
	void SetControlNewUnits( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetUniqueID()'
	CString GetUniqueID( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetQualifiedName()'
	CString GetQualifiedName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetCurrentPropertySetName(LPCTSTR)'
	CString GetCurrentPropertySetName( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'OverrideProperty(LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL OverrideProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'InheritProperty(LPCTSTR,LPCTSTR)'
	BOOL InheritProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'CreateProperty(LPCTSTR,LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL CreateProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetDefaultPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetDefaultPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'FindProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetAllProperties()'
	LPDISPATCH GetAllProperties( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetToolProperties(LPCTSTR)'
	LPDISPATCH GetToolProperties( LPCTSTR theToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsOverriddenProperty(LPCTSTR,LPCTSTR)'
	BOOL IsOverriddenProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsDefaultProperty(LPCTSTR,LPCTSTR)'
	BOOL IsDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'FindDefaultProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetPropertyClassName()'
	CString GetPropertyClassName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetDefaultSetNames(LPCTSTR)'
	LPDISPATCH GetDefaultSetNames( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'SetCurrentPropertySetName(LPCTSTR,LPCTSTR)'
	BOOL SetCurrentPropertySetName( LPCTSTR ToolName, LPCTSTR SetName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsControlled()'
	BOOL IsControlled( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsModified()'
	BOOL IsModified( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsModifiable()'
	BOOL IsModifiable( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetFileName()'
	CString GetFileName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetContainingControlledElement()'
	LPDISPATCH GetContainingControlledElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetControlledChildElements(BOOL)'
	LPDISPATCH GetControlledChildElements( BOOL bRecursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsOwned()'
	BOOL IsOwned( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsUnderSourceControl()'
	BOOL IsUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsCheckedOut()'
	BOOL IsCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsLoaded()'
	BOOL IsLoaded( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'Uncontrol()'
	BOOL Uncontrol( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'ControlChildElements(BOOL)'
	BOOL ControlChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'UncontrolChildElements(BOOL)'
	BOOL UncontrolChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'ControlTo(LPCTSTR)'
	BOOL ControlTo( LPCTSTR Path );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'Control()'
	BOOL Control( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsChildDirUnderSourceControl()'
	BOOL IsChildDirUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsControllableElementContainer()'
	BOOL IsControllableElementContainer( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsChildDirCheckedOut()'
	BOOL IsChildDirCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetChildDirName()'
	CString GetChildDirName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'IsScratchPad()'
	BOOL IsScratchPad( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetModelElement()'
	LPDISPATCH GetModelElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'DeleteExternalDocument(LPDISPATCH)'
	BOOL DeleteExternalDocument( LPDISPATCH pIDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'AddExternalDocument(LPCTSTR,long)'
	LPDISPATCH AddExternalDocument( LPCTSTR szName, long iType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'OpenSpecification()'
	BOOL OpenSpecification( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetClassifier()'
	LPDISPATCH GetClassifier( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetGeneralizations()'
	LPDISPATCH GetGeneralizations( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetSuperClasses()'
	LPDISPATCH GetSuperClasses( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetSubClasses()'
	LPDISPATCH GetSubClasses( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'AddGeneralization(LPCTSTR,LPCTSTR)'
	LPDISPATCH AddGeneralization( LPCTSTR theRelationName, LPCTSTR theParentClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'DeleteGeneralization(LPDISPATCH)'
	BOOL DeleteGeneralization( LPDISPATCH theGeneralization );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'AddOperation(LPCTSTR,LPCTSTR)'
	LPDISPATCH AddOperation( LPCTSTR theName, LPCTSTR retType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'DeleteOperation(LPDISPATCH)'
	BOOL DeleteOperation( LPDISPATCH theOper );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'AddAttribute(LPCTSTR,LPCTSTR,LPCTSTR)'
	LPDISPATCH AddAttribute( LPCTSTR theName, LPCTSTR theType, LPCTSTR initVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'DeleteAttribute(LPDISPATCH)'
	BOOL DeleteAttribute( LPDISPATCH theAttr );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetAssociations()'
	LPDISPATCH GetAssociations( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'AddAssociation(LPCTSTR,LPCTSTR)'
	LPDISPATCH AddAssociation( LPCTSTR theSupplierRoleName, LPCTSTR theSupplierRoleType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'DeleteAssociation(LPDISPATCH)'
	BOOL DeleteAssociation( LPDISPATCH thAss );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetAssociationEnds()'
	LPDISPATCH GetAssociationEnds( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetAssociateAssociationEnds()'
	LPDISPATCH GetAssociateAssociationEnds( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'CreateStateMachine()'
	void CreateStateMachine( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'DeleteStateMachine()'
	void DeleteStateMachine( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'AddRealizeRel(LPCTSTR,LPCTSTR)'
	LPDISPATCH AddRealizeRel( LPCTSTR theRelationName, LPCTSTR theSupplierName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'DeleteRealizeRel(LPDISPATCH)'
	BOOL DeleteRealizeRel( LPDISPATCH theRel );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetRealizeRelations()'
	LPDISPATCH GetRealizeRelations( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetClassDependencies()'
	LPDISPATCH GetClassDependencies( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'AddClassDependency(LPCTSTR,LPCTSTR)'
	LPDISPATCH AddClassDependency( LPCTSTR thSupplierName, LPCTSTR theSupplierType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'DeleteClassDependency(LPDISPATCH)'
	BOOL DeleteClassDependency( LPDISPATCH theDependency );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'AddCollaboration(LPCTSTR)'
	LPDISPATCH AddCollaboration( LPCTSTR theCollabName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'DeleteCollaboration(LPDISPATCH)'
	BOOL DeleteCollaboration( LPDISPATCH theCollab );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'AddGeneralizationEx(LPCTSTR,LPCTSTR,BOOL)'
	LPDISPATCH AddGeneralizationEx( LPCTSTR theRelationName, LPCTSTR theParentClassName, BOOL ExcludeSuperclassProps );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'DeleteGeneralizationEx(LPDISPATCH,BOOL)'
	BOOL DeleteGeneralizationEx( LPDISPATCH theGeneralization, BOOL AbsorbSuperClassProps );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::Capsule' operation 'GetStructure()'
	LPDISPATCH GetStructure( void );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::Capsule' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* Capsule_H */

// }}}RME
