// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage'

#ifndef DeploymentPackage_H
#define DeploymentPackage_H

#ifdef PRAGMA
#pragma interface "DeploymentPackage.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class DeploymentPackage : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~DeploymentPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	DeploymentPackage & operator=( const DeploymentPackage & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'DeploymentPackage()'
	DeploymentPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'DeploymentPackage(LPDISPATCH)'
	DeploymentPackage( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'DeploymentPackage(const DeploymentPackage&)'
	DeploymentPackage( const DeploymentPackage & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetVersion()'
	CString GetVersion( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'Save()'
	BOOL Save( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsSameInstance(LPDISPATCH)'
	BOOL IsSameInstance( LPDISPATCH Other );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetName()'
	CString GetName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetToolNames()'
	LPDISPATCH GetToolNames( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'SetName(LPCTSTR)'
	void SetName( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetApplication()'
	LPDISPATCH GetApplication( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetModel()'
	LPDISPATCH GetModel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetDocumentation()'
	CString GetDocumentation( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'SetDocumentation(LPCTSTR)'
	void SetDocumentation( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetStereotype()'
	CString GetStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'SetStereotype(LPCTSTR)'
	void SetStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetLocalizedStereotype()'
	CString GetLocalizedStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'SetLocalizedStereotype(LPCTSTR)'
	void SetLocalizedStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetExternalDocuments()'
	LPDISPATCH GetExternalDocuments( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetControlNewUnits()'
	BOOL GetControlNewUnits( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'SetControlNewUnits(BOOL)'
	void SetControlNewUnits( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetUniqueID()'
	CString GetUniqueID( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetQualifiedName()'
	CString GetQualifiedName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetCurrentPropertySetName(LPCTSTR)'
	CString GetCurrentPropertySetName( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'OverrideProperty(LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL OverrideProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'InheritProperty(LPCTSTR,LPCTSTR)'
	BOOL InheritProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'CreateProperty(LPCTSTR,LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL CreateProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetDefaultPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetDefaultPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'FindProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetAllProperties()'
	LPDISPATCH GetAllProperties( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetToolProperties(LPCTSTR)'
	LPDISPATCH GetToolProperties( LPCTSTR theToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsOverriddenProperty(LPCTSTR,LPCTSTR)'
	BOOL IsOverriddenProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsDefaultProperty(LPCTSTR,LPCTSTR)'
	BOOL IsDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'FindDefaultProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetPropertyClassName()'
	CString GetPropertyClassName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetDefaultSetNames(LPCTSTR)'
	LPDISPATCH GetDefaultSetNames( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'SetCurrentPropertySetName(LPCTSTR,LPCTSTR)'
	BOOL SetCurrentPropertySetName( LPCTSTR ToolName, LPCTSTR SetName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsControlled()'
	BOOL IsControlled( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsModified()'
	BOOL IsModified( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsModifiable()'
	BOOL IsModifiable( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetFileName()'
	CString GetFileName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetContainingControlledElement()'
	LPDISPATCH GetContainingControlledElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetControlledChildElements(BOOL)'
	LPDISPATCH GetControlledChildElements( BOOL bRecursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsOwned()'
	BOOL IsOwned( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsUnderSourceControl()'
	BOOL IsUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsCheckedOut()'
	BOOL IsCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsLoaded()'
	BOOL IsLoaded( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'Uncontrol()'
	BOOL Uncontrol( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'ControlChildElements(BOOL)'
	BOOL ControlChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'UncontrolChildElements(BOOL)'
	BOOL UncontrolChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'ControlTo(LPCTSTR)'
	BOOL ControlTo( LPCTSTR Path );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'Control()'
	BOOL Control( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsChildDirUnderSourceControl()'
	BOOL IsChildDirUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsControllableElementContainer()'
	BOOL IsControllableElementContainer( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsChildDirCheckedOut()'
	BOOL IsChildDirCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetChildDirName()'
	CString GetChildDirName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsScratchPad()'
	BOOL IsScratchPad( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetModelElement()'
	LPDISPATCH GetModelElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'DeleteExternalDocument(LPDISPATCH)'
	BOOL DeleteExternalDocument( LPDISPATCH pIDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'AddExternalDocument(LPCTSTR,long)'
	LPDISPATCH AddExternalDocument( LPCTSTR szName, long iType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'OpenSpecification()'
	BOOL OpenSpecification( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'IsRootPackage()'
	BOOL IsRootPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'ImportFile(LPCTSTR)'
	BOOL ImportFile( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'AddUnit(LPCTSTR)'
	BOOL AddUnit( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'AddSharedUnit(LPCTSTR)'
	BOOL AddSharedUnit( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'ImportFileEx(LPCTSTR)'
	LPDISPATCH ImportFileEx( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'TopLevel()'
	BOOL TopLevel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'AddProcessor(LPCTSTR)'
	LPDISPATCH AddProcessor( LPCTSTR pName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'DeleteProcessor(LPDISPATCH)'
	BOOL DeleteProcessor( LPDISPATCH pProcessor );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'AddDevice(LPCTSTR)'
	LPDISPATCH AddDevice( LPCTSTR pName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'DeleteDevice(LPDISPATCH)'
	BOOL DeleteDevice( LPDISPATCH pDevice );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetAllProcessors()'
	LPDISPATCH GetAllProcessors( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetAllDevices()'
	LPDISPATCH GetAllDevices( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetDeploymentDiagrams()'
	LPDISPATCH GetDeploymentDiagrams( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetParentDeploymentPackage()'
	LPDISPATCH GetParentDeploymentPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'GetDeploymentPackages()'
	LPDISPATCH GetDeploymentPackages( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'DeleteDeploymentPackage(LPDISPATCH)'
	BOOL DeleteDeploymentPackage( LPDISPATCH theDeploymentPackageToDelete );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'AddDeploymentPackage(LPCTSTR)'
	LPDISPATCH AddDeploymentPackage( LPCTSTR theName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'AddDeploymentDiagram(LPCTSTR)'
	LPDISPATCH AddDeploymentDiagram( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'DeleteDeploymentDiagram(LPDISPATCH)'
	BOOL DeleteDeploymentDiagram( LPDISPATCH theDeploymentDiagram );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'RelocateDevice(LPDISPATCH)'
	BOOL RelocateDevice( LPDISPATCH theDevice );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'RelocateProcessor(LPDISPATCH)'
	BOOL RelocateProcessor( LPDISPATCH theProcessor );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'RelocateDeploymentPackage(LPDISPATCH)'
	BOOL RelocateDeploymentPackage( LPDISPATCH theDeploymentPackage );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' operation 'RelocateDeploymentDiagram(LPDISPATCH)'
	BOOL RelocateDeploymentDiagram( LPDISPATCH theDeploymentDiagram );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::DeploymentPackage' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* DeploymentPackage_H */

// }}}RME
