// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection'

#ifndef GeneralizationCollection_H
#define GeneralizationCollection_H

#ifdef PRAGMA
#pragma interface "GeneralizationCollection.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class GeneralizationCollection : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~GeneralizationCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	GeneralizationCollection & operator=( const GeneralizationCollection & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'GeneralizationCollection()'
	GeneralizationCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'GeneralizationCollection(LPDISPATCH)'
	GeneralizationCollection( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'GeneralizationCollection(const GeneralizationCollection&)'
	GeneralizationCollection( const GeneralizationCollection & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'Add(LPDISPATCH)'
	void Add( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'GetCount()'
	short GetCount( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'GetAt(short)'
	LPDISPATCH GetAt( short Index );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'FindFirst(LPCTSTR)'
	short FindFirst( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'FindNext(short,LPCTSTR)'
	short FindNext( short iCurID, LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'IndexOf(LPDISPATCH)'
	short IndexOf( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'AddCollection(LPDISPATCH)'
	void AddCollection( LPDISPATCH theCollection );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'Remove(LPDISPATCH)'
	void Remove( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'RemoveAll()'
	void RemoveAll( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'GetFirst(LPCTSTR)'
	LPDISPATCH GetFirst( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'Exists(LPDISPATCH)'
	BOOL Exists( LPDISPATCH pObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' operation 'GetWithUniqueID(LPCTSTR)'
	LPDISPATCH GetWithUniqueID( LPCTSTR UniqueID );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::GeneralizationCollection' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* GeneralizationCollection_H */

// }}}RME
