// {{{RME classifier 'Logical View::RRTEI::LogicalPackage'

#ifndef LogicalPackage_H
#define LogicalPackage_H

#ifdef PRAGMA
#pragma interface "LogicalPackage.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class LogicalPackage : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~LogicalPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	LogicalPackage & operator=( const LogicalPackage & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'LogicalPackage()'
	LogicalPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'LogicalPackage(LPDISPATCH)'
	LogicalPackage( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'LogicalPackage(const LogicalPackage&)'
	LogicalPackage( const LogicalPackage & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetVersion()'
	CString GetVersion( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'Save()'
	BOOL Save( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsClass(LPCTSTR)'
	BOOL IsClass( LPCTSTR theClassName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IdentifyClass()'
	CString IdentifyClass( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsSameInstance(LPDISPATCH)'
	BOOL IsSameInstance( LPDISPATCH Other );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetName()'
	CString GetName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetToolNames()'
	LPDISPATCH GetToolNames( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'SetName(LPCTSTR)'
	void SetName( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetApplication()'
	LPDISPATCH GetApplication( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetModel()'
	LPDISPATCH GetModel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetDocumentation()'
	CString GetDocumentation( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'SetDocumentation(LPCTSTR)'
	void SetDocumentation( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetStereotype()'
	CString GetStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'SetStereotype(LPCTSTR)'
	void SetStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetLocalizedStereotype()'
	CString GetLocalizedStereotype( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'SetLocalizedStereotype(LPCTSTR)'
	void SetLocalizedStereotype( LPCTSTR propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetExternalDocuments()'
	LPDISPATCH GetExternalDocuments( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetParentLogicalPackage()'
	LPDISPATCH GetParentLogicalPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetCollaborations()'
	LPDISPATCH GetCollaborations( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetControlNewUnits()'
	BOOL GetControlNewUnits( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'SetControlNewUnits(BOOL)'
	void SetControlNewUnits( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetUniqueID()'
	CString GetUniqueID( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetQualifiedName()'
	CString GetQualifiedName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetCurrentPropertySetName(LPCTSTR)'
	CString GetCurrentPropertySetName( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'OverrideProperty(LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL OverrideProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'InheritProperty(LPCTSTR,LPCTSTR)'
	BOOL InheritProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'CreateProperty(LPCTSTR,LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL CreateProperty( LPCTSTR theToolName, LPCTSTR thePropName, LPCTSTR theValue, LPCTSTR theType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetDefaultPropertyValue(LPCTSTR,LPCTSTR)'
	CString GetDefaultPropertyValue( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'FindProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetAllProperties()'
	LPDISPATCH GetAllProperties( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetToolProperties(LPCTSTR)'
	LPDISPATCH GetToolProperties( LPCTSTR theToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsOverriddenProperty(LPCTSTR,LPCTSTR)'
	BOOL IsOverriddenProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsDefaultProperty(LPCTSTR,LPCTSTR)'
	BOOL IsDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'FindDefaultProperty(LPCTSTR,LPCTSTR)'
	LPDISPATCH FindDefaultProperty( LPCTSTR theToolName, LPCTSTR thePropName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetPropertyClassName()'
	CString GetPropertyClassName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetDefaultSetNames(LPCTSTR)'
	LPDISPATCH GetDefaultSetNames( LPCTSTR ToolName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'SetCurrentPropertySetName(LPCTSTR,LPCTSTR)'
	BOOL SetCurrentPropertySetName( LPCTSTR ToolName, LPCTSTR SetName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsControlled()'
	BOOL IsControlled( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsModified()'
	BOOL IsModified( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsModifiable()'
	BOOL IsModifiable( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetFileName()'
	CString GetFileName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetContainingControlledElement()'
	LPDISPATCH GetContainingControlledElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetControlledChildElements(BOOL)'
	LPDISPATCH GetControlledChildElements( BOOL bRecursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsOwned()'
	BOOL IsOwned( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsUnderSourceControl()'
	BOOL IsUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsCheckedOut()'
	BOOL IsCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'Uncontrol()'
	BOOL Uncontrol( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'ControlChildElements(BOOL)'
	BOOL ControlChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'UncontrolChildElements(BOOL)'
	BOOL UncontrolChildElements( BOOL Recursive );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'ControlTo(LPCTSTR)'
	BOOL ControlTo( LPCTSTR Path );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'Control()'
	BOOL Control( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsChildDirUnderSourceControl()'
	BOOL IsChildDirUnderSourceControl( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsControllableElementContainer()'
	BOOL IsControllableElementContainer( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsChildDirCheckedOut()'
	BOOL IsChildDirCheckedOut( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetChildDirName()'
	CString GetChildDirName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsScratchPad()'
	BOOL IsScratchPad( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetModelElement()'
	LPDISPATCH GetModelElement( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'DeleteExternalDocument(LPDISPATCH)'
	BOOL DeleteExternalDocument( LPDISPATCH pIDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'AddExternalDocument(LPCTSTR,long)'
	LPDISPATCH AddExternalDocument( LPCTSTR szName, long iType );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'OpenSpecification()'
	BOOL OpenSpecification( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetGeneralizations()'
	LPDISPATCH GetGeneralizations( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'AddGeneralization(LPCTSTR,LPCTSTR)'
	LPDISPATCH AddGeneralization( LPCTSTR theRelationName, LPCTSTR theParentLogicalPackageName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'DeleteGeneralization(LPDISPATCH)'
	BOOL DeleteGeneralization( LPDISPATCH theGeneralization );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetAssociations()'
	LPDISPATCH GetAssociations( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'AddCollaboration(LPCTSTR)'
	LPDISPATCH AddCollaboration( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'DeleteCollaboration(LPDISPATCH)'
	BOOL DeleteCollaboration( LPDISPATCH theCollaboration );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetUseCases()'
	LPDISPATCH GetUseCases( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'IsRootPackage()'
	BOOL IsRootPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'ImportFile(LPCTSTR)'
	BOOL ImportFile( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'AddUnit(LPCTSTR)'
	BOOL AddUnit( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'AddSharedUnit(LPCTSTR)'
	BOOL AddSharedUnit( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'ImportFileEx(LPCTSTR)'
	LPDISPATCH ImportFileEx( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'TopLevel()'
	BOOL TopLevel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetAllClasses()'
	LPDISPATCH GetAllClasses( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetAllLogicalPackages()'
	LPDISPATCH GetAllLogicalPackages( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetAllUseCases()'
	LPDISPATCH GetAllUseCases( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetAllCapsules()'
	LPDISPATCH GetAllCapsules( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetAllProtocols()'
	LPDISPATCH GetAllProtocols( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetGlobal()'
	BOOL GetGlobal( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'SetGlobal(BOOL)'
	void SetGlobal( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetClasses()'
	LPDISPATCH GetClasses( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetLogicalPackages()'
	LPDISPATCH GetLogicalPackages( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetClassDiagrams()'
	LPDISPATCH GetClassDiagrams( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetCapsules()'
	LPDISPATCH GetCapsules( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetProtocols()'
	LPDISPATCH GetProtocols( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'AddClass(LPCTSTR)'
	LPDISPATCH AddClass( LPCTSTR theName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'AddClassDiagram(LPCTSTR)'
	LPDISPATCH AddClassDiagram( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'AddLogicalPackage(LPCTSTR)'
	LPDISPATCH AddLogicalPackage( LPCTSTR theName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'RelocateClass(LPDISPATCH)'
	void RelocateClass( LPDISPATCH theClass );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'RelocateLogicalPackage(LPDISPATCH)'
	void RelocateLogicalPackage( LPDISPATCH theLogicalPackage );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'RelocateClassDiagram(LPDISPATCH)'
	void RelocateClassDiagram( LPDISPATCH theClsDiagram );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'DeleteLogicalPackage(LPDISPATCH)'
	BOOL DeleteLogicalPackage( LPDISPATCH theLogicalPackage );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'DeleteClass(LPDISPATCH)'
	BOOL DeleteClass( LPDISPATCH theClass );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'DeleteClassDiagram(LPDISPATCH)'
	BOOL DeleteClassDiagram( LPDISPATCH theClassDiagram );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetAssignedComponentPackage()'
	LPDISPATCH GetAssignedComponentPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'SetAssignedComponentPackage(LPDISPATCH)'
	void SetAssignedComponentPackage( LPDISPATCH newValue );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'HasAssignedComponentPackage()'
	BOOL HasAssignedComponentPackage( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'DeleteUseCase(LPDISPATCH)'
	BOOL DeleteUseCase( LPDISPATCH theUseCase );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'AddUseCase(LPCTSTR)'
	LPDISPATCH AddUseCase( LPCTSTR szName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'AddLogicalPackageDependency(LPCTSTR,LPCTSTR)'
	LPDISPATCH AddLogicalPackageDependency( LPCTSTR theName, LPCTSTR theSupplierLogicalPackageName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetLogicalPackageDependencies()'
	LPDISPATCH GetLogicalPackageDependencies( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'DeleteLogicalPackageDependency(LPDISPATCH)'
	BOOL DeleteLogicalPackageDependency( LPDISPATCH theDependency );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'AddCapsule(LPCTSTR)'
	LPDISPATCH AddCapsule( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'DeleteCapsule(LPDISPATCH)'
	BOOL DeleteCapsule( LPDISPATCH theCapsule );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'RelocateCapsule(LPDISPATCH)'
	BOOL RelocateCapsule( LPDISPATCH theCapsule );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'AddProtocol(LPCTSTR)'
	LPDISPATCH AddProtocol( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'DeleteProtocol(LPDISPATCH)'
	BOOL DeleteProtocol( LPDISPATCH theProtocol );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'RelocateProtocol(LPDISPATCH)'
	BOOL RelocateProtocol( LPDISPATCH theProtocol );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'RelocateCollaboration(LPDISPATCH)'
	BOOL RelocateCollaboration( LPDISPATCH theCollaboration );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetSuperLogicalPackages()'
	LPDISPATCH GetSuperLogicalPackages( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' operation 'GetSubLogicalPackages()'
	LPDISPATCH GetSubLogicalPackages( void );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::LogicalPackage' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* LogicalPackage_H */

// }}}RME
