// {{{RME classifier 'Logical View::StdAfx'

#ifndef StdAfx_H
#define StdAfx_H

#ifdef PRAGMA
#pragma interface "StdAfx.h"
#endif

#include <RTSystem/rrtres.h>

// {{{RME classifier 'Logical View::StdAfx' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// This preface contains many of the different options provided by MFC
//  that you can enable/disable depending on what your application
//  will use. It will improved the speed of compilations if as many of these
//  are commented out as possible.

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define VC_EXTRALEAN		// Exclude rarely-used stuff from Windows headers

#include <afxwin.h>			// MFC core and standard components
#include <afxext.h>			// MFC extensions
#include <afxole.h>			// MFC OLE classes
#include <afxodlgs.h>			// MFC OLE dialog classes
#include <afxdisp.h>			// MFC Automation classes
//#include <afxdb.h>			// MFC ODBC database classes
//#include <afxdao.h>			// MFC DAO database classes
//#include <afxdtctl.h>			// MFC support for Internet Explorer 4 Common Controls
//#include <afxcmn.h>			// MFC support for Windows Common Controls

// }}}USR
// }}}RME

// {{{RME classifier 'Logical View::StdAfx' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* StdAfx_H */

// }}}RME
