// {{{RME classifier 'Logical View::RRTEI::_Application'

#ifndef _Application_H
#define _Application_H

#ifdef PRAGMA
#pragma interface "_Application.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::_Application' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class _Application : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::_Application' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::_Application' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::_Application' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetVisible()'
	BOOL GetVisible( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'SetVisible(BOOL)'
	void SetVisible( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetTop()'
	short GetTop( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'SetTop(short)'
	void SetTop( short propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetLeft()'
	short GetLeft( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'SetLeft(short)'
	void SetLeft( short propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetHeight()'
	short GetHeight( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'SetHeight(short)'
	void SetHeight( short propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetWidth()'
	short GetWidth( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'SetWidth(short)'
	void SetWidth( short propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetCurrentModel()'
	LPDISPATCH GetCurrentModel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetBrowserVisible()'
	BOOL GetBrowserVisible( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'SetBrowserVisible(BOOL)'
	void SetBrowserVisible( BOOL propVal );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetPathMap()'
	LPDISPATCH GetPathMap( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetVersion()'
	CString GetVersion( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetProductName()'
	CString GetProductName( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetApplicationPath()'
	CString GetApplicationPath( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetCommandLine()'
	CString GetCommandLine( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetAddInManager()'
	LPDISPATCH GetAddInManager( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetCurrentWorkspace()'
	LPDISPATCH GetCurrentWorkspace( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'OpenModel(LPCTSTR)'
	LPDISPATCH OpenModel( LPCTSTR theModel );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'NewModel()'
	LPDISPATCH NewModel( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'Exit()'
	void Exit( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'WriteErrorLog(LPCTSTR)'
	void WriteErrorLog( LPCTSTR theMsg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'Save(BOOL)'
	void Save( BOOL bSaveUnits );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'SaveAs(LPCTSTR,BOOL)'
	void SaveAs( LPCTSTR theFile, BOOL bSaveUnits );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'OpenScript(LPCTSTR)'
	void OpenScript( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'NewScript()'
	void NewScript( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'CompileScriptFile(LPCTSTR,LPCTSTR,BOOL)'
	void CompileScriptFile( LPCTSTR FileName, LPCTSTR BinaryName, BOOL bDebug );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'OpenModelAsTemplate(LPCTSTR)'
	LPDISPATCH OpenModelAsTemplate( LPCTSTR szFileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'OpenURL(LPCTSTR)'
	BOOL OpenURL( LPCTSTR theURL );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'OpenExternalDocument(LPCTSTR)'
	BOOL OpenExternalDocument( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetProfileString(LPCTSTR,LPCTSTR,LPCTSTR)'
	CString GetProfileString( LPCTSTR Section, LPCTSTR Entry, LPCTSTR Default );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'WriteProfileString(LPCTSTR,LPCTSTR,LPCTSTR)'
	BOOL WriteProfileString( LPCTSTR Section, LPCTSTR Entry, LPCTSTR Value );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetLicensedApplication(LPCTSTR)'
	LPDISPATCH GetLicensedApplication( LPCTSTR theKey );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'ExecuteScript(LPCTSTR)'
	void ExecuteScript( LPCTSTR pFileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'SetBuildSettings(BOOL,BOOL,BOOL,BOOL,BOOL)'
	void SetBuildSettings( BOOL ShowWarnings, BOOL VerifyConnectorCardinality, BOOL VerifyBranchTransitions, BOOL VerifyDeadUnreachableStates, BOOL VerifyUntriggeredTransitions );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'SaveGenerationResultsAs(LPCTSTR)'
	BOOL SaveGenerationResultsAs( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'Get(LPDISPATCH)'
	BOOL Get( LPDISPATCH pElements );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'CheckOut(LPDISPATCH)'
	BOOL CheckOut( LPDISPATCH pElements );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'UnCheckOut(LPDISPATCH)'
	BOOL UnCheckOut( LPDISPATCH pElements );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'CheckIn(LPDISPATCH,LPCTSTR)'
	BOOL CheckIn( LPDISPATCH pElements, LPCTSTR Comment );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'RefreshStatus(LPDISPATCH)'
	BOOL RefreshStatus( LPDISPATCH pElements );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'Add(LPDISPATCH,BOOL,LPCTSTR)'
	BOOL Add( LPDISPATCH pElements, BOOL addDirsToo, LPCTSTR Comment );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'AddDir(LPDISPATCH,LPCTSTR)'
	BOOL AddDir( LPDISPATCH pElements, LPCTSTR Comment );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'IsSourceControlEnabled()'
	BOOL IsSourceControlEnabled( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'WriteBuildOutput(LPCTSTR)'
	void WriteBuildOutput( LPCTSTR strMessage );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'WriteBuildError(LPCTSTR,LPDISPATCH,short,BOOL)'
	void WriteBuildError( LPCTSTR strError, LPDISPATCH pElement, short nLineNumber, BOOL bIsWarning );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'WriteErrorLogEx(LPCTSTR,LPDISPATCH,BOOL)'
	void WriteErrorLogEx( LPCTSTR pszMessage, LPDISPATCH pModelElement, BOOL bIsWarning );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'OpenWorkspace(LPCTSTR)'
	LPDISPATCH OpenWorkspace( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'SaveWorkspace()'
	void SaveWorkspace( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'SaveWorkspaceAs(LPCTSTR)'
	void SaveWorkspaceAs( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'CreateCollection()'
	LPDISPATCH CreateCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'CheckInDir(LPDISPATCH,LPCTSTR)'
	BOOL CheckInDir( LPDISPATCH pElements, LPCTSTR Comment );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'SelectObjectsInBrowsers(LPDISPATCH)'
	void SelectObjectsInBrowsers( LPDISPATCH theObjects );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'WriteBuildErrorEx(LPCTSTR,LPDISPATCH,short,BOOL,LPDISPATCH)'
	void WriteBuildErrorEx( LPCTSTR strError, LPDISPATCH pElement, short nLineNumber, BOOL bIsWarning, LPDISPATCH pContext );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'SaveLogAs(LPCTSTR)'
	BOOL SaveLogAs( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'LoadScript(LPCTSTR)'
	void LoadScript( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'FreeScript(LPCTSTR)'
	void FreeScript( LPCTSTR FileName );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'ReportCodeSync(LPDISPATCH,LPDISPATCH,LPDISPATCH)'
	void ReportCodeSync( LPDISPATCH ocModelElements, LPDISPATCH ocContextElements, LPDISPATCH ocReplaceStrings );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'SelectLogPane()'
	void SelectLogPane( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'Browse(LPDISPATCH,LPDISPATCH,short)'
	void Browse( LPDISPATCH pElement, LPDISPATCH pContext, short nLineNumber );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation '_Application()'
	_Application( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation '_Application(LPDISPATCH)'
	_Application( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_Application' operation '_Application(const _Application&)'
	_Application( const _Application & dispatchSrc );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::_Application' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* _Application_H */

// }}}RME
