// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection'

#ifndef _ControllableElementCollection_H
#define _ControllableElementCollection_H

#ifdef PRAGMA
#pragma interface "_ControllableElementCollection.h"
#endif

#include <RTSystem/rrtres.h>
#include <COleDispatchDriver.h>

// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class _ControllableElementCollection : public COleDispatchDriver
{
public:
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~_ControllableElementCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	_ControllableElementCollection & operator=( const _ControllableElementCollection & rtg_arg );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation '_ControllableElementCollection()'
	_ControllableElementCollection( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation '_ControllableElementCollection(LPDISPATCH)'
	_ControllableElementCollection( LPDISPATCH pDispatch );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation '_ControllableElementCollection(const _ControllableElementCollection&)'
	_ControllableElementCollection( const _ControllableElementCollection & dispatchSrc );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation 'Add(LPDISPATCH)'
	void Add( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation 'GetObject()'
	LPDISPATCH GetObject( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation 'GetCount()'
	short GetCount( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation 'GetAt(short)'
	LPDISPATCH GetAt( short Index );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation 'FindFirst(LPCTSTR)'
	short FindFirst( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation 'FindNext(short,LPCTSTR)'
	short FindNext( short iCurID, LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation 'IndexOf(LPDISPATCH)'
	short IndexOf( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation 'AddCollection(LPDISPATCH)'
	void AddCollection( LPDISPATCH theCollection );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation 'Remove(LPDISPATCH)'
	void Remove( LPDISPATCH theObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation 'RemoveAll()'
	void RemoveAll( void );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation 'GetFirst(LPCTSTR)'
	LPDISPATCH GetFirst( LPCTSTR Name );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation 'Exists(LPDISPATCH)'
	BOOL Exists( LPDISPATCH pObject );
	// }}}RME
	// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' operation 'GetWithUniqueID(LPCTSTR)'
	LPDISPATCH GetWithUniqueID( LPCTSTR UniqueID );
	// }}}RME
};

// {{{RME classifier 'Logical View::RRTEI::_ControllableElementCollection' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* _ControllableElementCollection_H */

// }}}RME
